#!/usr/bin/env python
# -*- coding: UTF-8 -*-

###############################################################################
#
#  Copyright (C) 2007 Eric Streit <Eric.Streit@wanadoo.fr>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
################################################################################


import pygtk
# mandatory for installation with both pygtk1 and pygtk2
pygtk.require("2.0")
import gtk

import os, sys

from gtk import gdk
import gobject
import pango


# rajouter  : signal de saturation, clear (efface et mets les valeurs à jour)
#           : signal de start et stop

class SVUMeter(gtk.DrawingArea):
    __gsignals__ = {
                     'expose-event' : 'override',
                     'size-allocate': 'override',
                     'size-request' : 'override',
                     'realize'      : 'override'
                   }

    __gproperties__ = {
#        'bloclength' :(gobject.TYPE_FLOAT,
#                        'bloc length',
#                        'The size of the minimal bloc in s',
#                        0.005,
#                        1.0,
#                        0.05,
#                        gobject.PARAM_READWRITE),
#        'prelength'  :(gobject.TYPE_FLOAT,
#                        'pre length',
#                        'the prerecording size in s',
#                        0.0,
#                        10.0,
#                        0.3,
#                        gobject.PARAM_READWRITE),
#        'runlength'  :(gobject.TYPE_FLOAT,
#                        'run length',
#                        'the postrecording size before cut in s',
#                        0.0,
#                        10.0,
#                        1.0,
#                        gobject.PARAM_READWRITE),
#        'thresholddb' :(gobject.TYPE_FLOAT,
#                        'threshold db',
#                        'the treshold for  starting message in db',
#                        -90.0,
#                        0.0,
#                        -45.0,
#                        gobject.PARAM_READWRITE),
#        'maxnoise'   :(gobject.TYPE_FLOAT,
#                        'max noise',
#                        'maximum noise level in db',
#                        -90.0,
#                        0.0,
#                        -50.0,
#                        gobject.PARAM_READWRITE),
#        'saturation'  :(gobject.TYPE_FLOAT,
#                        'saturation',
#                        'saturation level in db',
#                        -90.0,
#                        0.0,
#                        -5.0,
#                        gobject.PARAM_READWRITE),
#        'minimumsize'  :(gobject.TYPE_FLOAT,
#                        'minimum_size',
#                        'minimum_size of a record',
#                        0.0,
#                        5.0,
#                        0.15,
#                        gobject.PARAM_READWRITE),
        'parameters'   :(gobject.TYPE_PYOBJECT,
                         'parameters',
                         'the parameters dictionnary',
                         gobject.PARAM_READWRITE)
                }

    # les marges qui nous permettront de mettre des indications
    # marging: to post some indications
    topborder = 20
    bottomborder = 50
    leftborder = 120
    rightborder = 70
    # les contextes graphiques
    # graphic contexts
    background_gc = None
    marging_background_gc = None
    level_gc = None
    pre_and_post_length_gc = None
    horizontal_lines_gc = None
    vertical_lines_gc = None
    # les valeurs des propriétés
    # proprieties values
    saturation = -20.0
    max_noise = -30.0
    thresholddb = -20.0
    run_length = 1.0
    pre_length = 0.3
    bloc_length = 0.05
    peaklevel = -90.0
    decaylevel = -90.0
    minimum_size = 0.15
    #
    my_queue = []
    tick_size = 5
    header_drawing = True
    saturation_toggle = False
    starting = False
    long_word = False
    total_draw = True
    parameters = {}

    # Returns the meter deflection percentage given a db value
    def iec_scale(self, db):
        pct = 0.0

        if db < -70.0:
            pct = 0.0
        elif db < -60.0:
            pct = (db + 70.0) * 0.25
        elif db < -50.0:
            pct = (db + 60.0) * 0.5 + 2.5
        elif db < -40.0:
            pct = (db + 50.0) * 0.75 + 7.5
        elif db < -30.0:
            pct = (db + 40.0) * 1.5 + 15.0
        elif db < -20.0:
            pct = (db + 30.0) * 2.0 + 30.0
        elif db < 0.0:
            pct = (db + 20.0) * 2.5 + 50.0
        else:
            pct = 100.0
        return pct

    def do_get_property(self, property):
#        if property.name == 'bloclength':
#            return self.bloc_length
#        elif property.name == 'prelength':
#            return self.pre_length
#        elif property.name == 'runlength':
#            return self.run_length
#        elif property.name == 'thresholddb':
#            return self.thresholddb
#        elif property.name == 'maxnoise':
#            return self.max_noise
#        elif property.name == 'saturation' :
#            return self.saturation
#        elif property.name == 'minimumsize' :
#            return self.minimum_size
        if property.name == "parameters":
            return self.parameters
        else:
            raise AttributeError, 'unknown property %s' % property.name

    def do_set_property(self, property, value):
#        if property.name == 'bloclength':
#            self.bloc_length = value
#        elif property.name == 'prelength':
#            self.pre_length = value
#        elif property.name == 'runlength':
#            self.run_length = value
#        elif property.name == 'thresholddb':
#            self.thresholddb = value
#        elif property.name == 'maxnoise':
#            self.max_noise = value
#        elif property.name == 'saturation' :
#            self.saturation = value
#            print "valeur après transmission: ", self.saturation
#        elif property.name == 'minimumsize' :
#            self.minimum_size = value
        if property.name == "parameters":
            self.parameters = value
            #print "paramètres après transmission:", self.parameters
        else:
            raise AttributeError, 'unknown property %s' % property.name
        # drawing eveything in the queue
        self.queue_draw()

    def do_size_request(self, requisition):
        requisition.width  = 600
        requisition.height = 300

    def do_size_allocate(self,allocation):
        self.allocation = allocation
        if self.flags() & gtk.REALIZED:
            self.window.move_resize(*allocation)

    def set_decay(self,f_decay):
        self.decay = f_decay

    def set_peaklevel(self,f_peaklevel):
        self.peaklevel = f_peaklevel

    def set_saturation_on(self):
        self.saturation_toggle = True

    def set_saturation_off(self):
        self.saturation_toggle = False

    def set_start_toggle(self, f_bool):
        self.starting = f_bool

    def set_restart(self):
        self.header_drawing = True
        self.saturation_toggle = False
        self.starting = False

    def set_colors(self,f_color1,f_color2,f_color3,f_color4,f_color5,f_background):
        self.color1 = f_color1
        self.color2 = f_color2
        self.color3 = f_color3
        self.color4 = f_color4
        self.color5 = f_color5
        self.background = f_background

    def set_parameters(self):
        #self.parameters = f_parameters
        # font
        self.font = pango.FontDescription(self.parameters["vu_font"])
        # colors
        colormap = gtk.gdk.colormap_get_system()
        green           = colormap.alloc_color(self.parameters["vu_minimum_size_color"][0], \
                                                    self.parameters["vu_minimum_size_color"][1], \
                                                    self.parameters["vu_minimum_size_color"][2])
        red             = colormap.alloc_color(65535, 0, 0)
        blue            = colormap.alloc_color(self.parameters["vu_signal_color"][0], \
                                                    self.parameters["vu_signal_color"][1], \
                                                    self.parameters["vu_signal_color"][2])
        light_grey      = colormap.alloc_color(50000, 50000, 50000)
        yellow          = colormap.alloc_color(self.parameters["vu_background"][0], \
                                                    self.parameters["vu_background"][1], \
                                                    self.parameters["vu_background"][2])
        light_yellow    = colormap.alloc_color(self.parameters["vu_pre_length_color"][0], \
                                                    self.parameters["vu_pre_length_color"][1], \
                                                    self.parameters["vu_pre_length_color"][2])

        # the graphic contexts
        self.green_gc = gdk.GC(self.window, foreground=green)
        self.blue_gc = gdk.GC(self.window, foreground=blue)
        self.red_gc = gdk.GC(self.window, foreground=red)
        self.yellow_gc = gdk.GC(self.window, foreground=yellow)
        self.light_grey_gc = gdk.GC(self.window, foreground=light_grey)
        self.light_yellow_gc = gdk.GC(self.window, foreground=light_yellow)
        # the properties
        self.bloclength = self.parameters["vu_bloc_length"]
        self.pre_length = self.parameters["pre_length"]
        self.run_length = self.parameters["run_length"]
        self.thresholddb = self.parameters["threshold"]
        self.max_noise = self.parameters["vu_max_noise"]
        self.saturation = self.parameters["saturation_level"]



    def do_realize(self):
        self.set_flags(self.flags() | gtk.REALIZED)
        # we get the attached window
        self.window = gdk.Window(self.get_parent_window(),
                                 width=self.allocation.width,
                                 height=self.allocation.height,
                                 window_type=gdk.WINDOW_CHILD,
                                 wclass=gdk.INPUT_OUTPUT,
                                 event_mask=self.get_events() | gdk.EXPOSURE_MASK)
        # colors used when drawing
        colormap = gtk.gdk.colormap_get_system()
        green           = colormap.alloc_color(0, 65535, 0)
        red             = colormap.alloc_color(65535, 0, 0)
        blue            = colormap.alloc_color(0, 0, 65535)
        light_grey      = colormap.alloc_color(50000, 50000, 50000)
        yellow          = colormap.alloc_color(65535, 65535, 0)
        light_yellow    = colormap.alloc_color(50000, 50000, 0)

        # the graphic contexts
        self.green_gc = gdk.GC(self.window, foreground=green)
        self.blue_gc = gdk.GC(self.window, foreground=blue)
        self.red_gc = gdk.GC(self.window, foreground=red)
        self.yellow_gc = gdk.GC(self.window, foreground=yellow)
        self.light_grey_gc = gdk.GC(self.window, foreground=light_grey)
        self.light_yellow_gc = gdk.GC(self.window, foreground=light_yellow)
        # the end
        self.window.set_user_data(self)
        self.style.attach(self.window)
        self.style.set_background(self.window, gtk.STATE_NORMAL)

    def calculate_values(self):
        self.queue_length = len(self.my_queue)
        if self.queue_length < 250:
            self.my_queue.append(self.peaklevel)
        else:
            self.my_queue.pop(0)
            self.my_queue.append(self.peaklevel)



    def do_expose_event(self,event):
        self.chain(event)
        x, y, w, h = self.allocation
        # debug print x, y, w, h
        vumeter_width = w - (self.leftborder + self.rightborder)
        vumeter_height = h - (self.topborder + self.bottomborder)
        # number of ticks (vumeter size / size of tick)
        total_ticks_number = int(vumeter_width / self.tick_size)
        # fill the queue (2 mn of ticks stored)
        self.calculate_values()
        # drawing the whool widget without the signal
        # drawing of the margins background in light grey
        self.window.draw_rectangle(self.light_grey_gc, True,
                                   0,0,w,h)
        # drawing of the rest background
        self.window.draw_rectangle(self.yellow_gc, True,
                                   self.leftborder, self.topborder,
                                   vumeter_width,
                                   vumeter_height)
        # the DB scale
        # draw tick marks
        scalers = [
            ('90 db', 0.0),
            ('40 db', 0.15),
            ('30 db', 0.30),
            ('20 db', 0.50),
            ('10 db', 0.75),
            (' 5 db', 0.875),
            (' 0 db', 1.0),
        ]
        for level, scale in scalers:
            # tick mark, 6 pixels high
            # we cheat again here by putting the 0 at the first pixel (x1,y1,x2,y2)
            self.window.draw_line(self.style.black_gc,
                w - self.rightborder,
                h - self.bottomborder - int(scale * (vumeter_height -1)),
                w -self.rightborder + 7,
                h - self.bottomborder - int(scale * (vumeter_height -1)))
            # tick label
            layout = self.create_pango_layout(level)
            layout.set_font_description(self.font)
            layout_width, layout_height = layout.get_pixel_size()
            self.window.draw_layout(self.style.black_gc,
                w - self.rightborder + 10,
                h - self.bottomborder - int(scale * (vumeter_height -1))  - int(layout_height / 2), layout)
        # draw time stamps
        # here, we have two cases
        #    * first: the time stamps begin with 0
        #    * second, the panel is scolling and we need to scroll the times ;)

        time_part_pixel = int((total_ticks_number / 10) * self.tick_size)
        total_time = total_ticks_number * self.bloc_length
        part_time = total_time / 10
        layout = self.create_pango_layout("Secondes")

        layout.set_font_description(self.font)
        self.window.draw_layout(self.style.black_gc,
            3,
            h - self.bottomborder + (layout_height/2),
             layout)
        for i in range(11):
            # draw the little lines
            self.window.draw_line(self.style.black_gc,
                self.leftborder + (i * time_part_pixel),
                h - self.bottomborder,
                self.leftborder + (i * time_part_pixel),
                h - self.bottomborder + 5)
            # draw time indications
            # draw_layout(gc, x, y, layout, foreground=None, background=None
            # pygtk string formating : '%(#).1F' % {"#":123.456}
            if self.total_draw:
                layout = self.create_pango_layout('%(#).1F' % {"#":(part_time * i)})
                layout.set_font_description(self.font)
            else:
                beginning = self.word_total_time - total_time
                layout = self.create_pango_layout('%(#).1F' % {"#":(beginning + (part_time * i))})
                layout.set_font_description(self.font)
            layout_width, layout_height = layout.get_pixel_size()
            self.window.draw_layout(self.style.black_gc,
            self.leftborder + (i * time_part_pixel) - (layout_width /2),
            h - self.bottomborder + (layout_height/2),
             layout)

        # draw the pre-length part
         # first, the number of ticks for the pre-length part
        pre_length_number = int(self.pre_length / self.bloc_length)
         # the rest of ticks to draw
        #post_length_number = total_ticks_number - pre_length_number
        if self.header_drawing :
            self.window.draw_rectangle(self.light_yellow_gc, True,
                self.leftborder,
                self.topborder,
                pre_length_number *  self.tick_size,
                vumeter_height
                )
            # draw the minimum time for one word
            self.window.draw_rectangle(self.green_gc, True,
                    self.leftborder + pre_length_number *  self.tick_size,
                    self.topborder,
                    int(self.minimum_size / self.bloc_length) * self.tick_size ,
                    vumeter_height
                    )
        # draw the different lines (saturation, noise, threshold)
        # threshold
        self.window.draw_line(self.style.black_gc,
            self.leftborder,
            h - self.bottomborder - ( int(vumeter_height * (self.iec_scale(self.thresholddb) / 100) )),
            w - self.rightborder,
            h - self.bottomborder - ( int(vumeter_height * (self.iec_scale(self.thresholddb) / 100) ))
            )
        layout = self.create_pango_layout("Threshold")
        layout.set_font_description(self.font)
        #my_context = layout.get_context()
        #my_context.get_font_description().set_size(1000)
        layout_width, layout_height = layout.get_pixel_size()
        self.window.draw_layout(self.style.black_gc,
            3,
            h - self.bottomborder - ( int(vumeter_height * (self.iec_scale(self.thresholddb) / 100) )) - int(layout_height / 1.5),
             layout)
        # saturation
        self.window.draw_line(self.red_gc,
            self.leftborder,
            h - self.bottomborder - ( int(vumeter_height * (self.iec_scale(self.saturation) / 100) )),
            w - self.rightborder,
            h - self.bottomborder - ( int(vumeter_height * (self.iec_scale(self.saturation) / 100) ))
            )
        layout = self.create_pango_layout("Saturation")
        layout.set_font_description(self.font)
        layout_width, layout_height = layout.get_pixel_size()
        self.window.draw_layout(self.style.black_gc,
            3,
            h - self.bottomborder - ( int(vumeter_height * (self.iec_scale(self.saturation) / 100) )) - int(layout_height / 1.5),
             layout)
        # noise
        self.window.draw_line(self.style.black_gc,
            self.leftborder,
            h - self.bottomborder - ( int(vumeter_height * (self.iec_scale(self.max_noise) / 100) )),
            w - self.rightborder,
            h - self.bottomborder - ( int(vumeter_height * (self.iec_scale(self.max_noise) / 100) ))
            )
        layout = self.create_pango_layout("Noise level")
        layout.set_font_description(self.font)
        layout_width, layout_height = layout.get_pixel_size()
        self.window.draw_layout(self.style.black_gc,
            3,
            h - self.bottomborder - ( int(vumeter_height * (self.iec_scale(self.max_noise) / 100) )) - int(layout_height / 1.5),
             layout)
        # end of widget part

        # signal part
        if not self.starting:
            if self.queue_length > 0:
                for i in range(pre_length_number % self.queue_length):
                    # debug print "i", i
                    valeur = int(vumeter_height * (self.iec_scale(self.my_queue[self.queue_length -1 -i]) / 100) )
                    self.window.draw_rectangle(self.blue_gc, False,
                        self.leftborder + ((pre_length_number-1) * self.tick_size) - (i * self.tick_size),
                        h - self.bottomborder - valeur,
                        self.tick_size,
                        valeur
                        )
            # TODO: make a fonction of this to draw or not
            if self.saturation_toggle:
                layout = self.create_pango_layout("Saturation !")
                self.window.draw_layout(self.style.black_gc,
                    int(vumeter_width / 2) +  self.leftborder,
                    int(vumeter_height / 2),
                 layout)
            # calaculate the depart point in the queue  for drawing all the word
            self.depart = self.queue_length - pre_length_number -1
            if self.depart < 0:
                self.depart = 0
            self.total_draw = True
            self.word_total_time = pre_length_number * self.bloc_length
        else:
            self.word_total_time = self.word_total_time + self.bloc_length
            #print self.word_total_time
            # Saturation indication
            if self.saturation_toggle:
                layout = self.create_pango_layout("Saturation !")
                self.window.draw_layout(self.style.black_gc,
                    int(vumeter_width / 2) +  self.leftborder,
                    int(vumeter_height / 2),
                 layout)
        # drawing of the word recording
        # we need to draw the prelength and the rest
            # calculate the start position in the queue
#            if self.queue_length < 250:
#                i = self.depart -1
            if self.queue_length == 250:
                self.depart = self.depart -1
                if self.depart < 0:
                    self.depart = 0
                    # DEBUG:
                    #print "phrase too long !"
            # drawing the complete signal
            # calculate the numebr of ticks to draw
            ticks_number = self.queue_length - self.depart - pre_length_number
            # DEBUG:
            # print "ticks number :",ticks_number, " queue length :", self.queue_length, " depart :", self.depart , " pre-length :", pre_length_number
            # TOD0: here add something to show only 2/3 of the drawing area when the
            # sounds does'nt fit in the window
            if (ticks_number > total_ticks_number):
                self.header_drawing = False
                ticks_number = int(total_ticks_number * 2 / 3)
                self.x = ticks_number
                self.depart = self.queue_length - ticks_number
                self.total_draw = False
            #print "ticks number", ticks_number
            offset = 0
            if not self.total_draw:
                offset = ticks_number - self.x
                ticks_number = self.x
            for i in range (ticks_number):
                valeur = int(vumeter_height * (self.iec_scale(self.my_queue[self.depart + offset + i]) / 100) )
                positionx = self.leftborder + (i  * self.tick_size)
                # DEBUG:
                # print positionx
#                if positionx > (self.leftborder + vumeter_width):
#                    self.tick_size = 1
                self.window.draw_rectangle(self.blue_gc, False,
                    positionx,
                    h - self.bottomborder - valeur,
                    self.tick_size,
                    valeur
                    )


gobject.type_register(SVUMeter)
