#!/usr/bin/env python
# -*- coding: UTF-8 -*-

###############################################################################
#
#  Copyright (C) 2007 Eric Streit <Eric.Streit@wanadoo.fr>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
################################################################################

import sys
import pygtk
# mandatory for installation with both pygtk1 and pygtk2
pygtk.require("2.0")
import gtk
import pango
import gobject

import time


class Wordsview:
    """
    class responsible of viewing the list of words to be recorded,
    and with the actual word highlighted
    """

    def __init__(self,f_widget,f_word_list,f_parameters):
        self.my_textwidget = f_widget
        self.buffer1 = self.my_textwidget.get_buffer()
        self.word_list = f_word_list
        self.parameters = f_parameters
        self.n = 0


    def set_colors(self):
        self.color1 = gtk.gdk.Color(self.parameters["wv_color1"][0],self.parameters["wv_color1"][1],self.parameters["wv_color1"][2])
        self.color2 = gtk.gdk.Color(self.parameters["wv_color2"][0],self.parameters["wv_color2"][1],self.parameters["wv_color2"][2])
        self.color3 = gtk.gdk.Color(self.parameters["wv_color3"][0],self.parameters["wv_color3"][1],self.parameters["wv_color3"][2])
        self.color4 = gtk.gdk.Color(self.parameters["wv_color4"][0],self.parameters["wv_color4"][1],self.parameters["wv_color4"][2])
        self.background = gtk.gdk.Color(self.parameters["wv_background"][0],self.parameters["wv_background"][1],self.parameters["wv_background"][2])


    def normal(self,f_mot):
        # on se positionne au début
        #startiter = self.buffer1.get_start_iter()
        # on lance la recherche
        debut, fin = self.running_iter.forward_search(f_mot, gtk.TEXT_SEARCH_TEXT_ONLY, limit=None)
        # on enlève le vieux tag
        self.buffer1.remove_tag_by_name("fg_red",debut,fin)
        #self.buffer1.remove_all_tags(debut, fin)
        # on applique le tag
        self.buffer1.apply_tag_by_name("fg_bblue",debut,fin)
        marquefin = self.buffer1.create_mark("fin",fin)
        self.my_textwidget.scroll_mark_onscreen(marquefin)
        self.buffer1.delete_mark(marquefin)

    def highlighted(self, f_mot):
        # on se positionne au début
        #startiter = self.buffer1.get_start_iter()
        # on lance la recherche
        debut, fin = self.running_iter.forward_search(f_mot, gtk.TEXT_SEARCH_TEXT_ONLY, limit=None)
        # on mets à jour le iter itinérant
        self.running_iter = debut
        # on enlève le vieux tag
#        self.buffer1.remove_tag_by_name("fg_bblue",debut,fin)
        # on applique le tag
        self.buffer1.apply_tag_by_name("fg_red",debut,fin)
        marquefin = self.buffer1.create_mark("fin",fin)
        self.my_textwidget.scroll_mark_onscreen(marquefin)
        self.buffer1.delete_mark(marquefin)
        self.actual_word = f_mot

    def forward(self,f_word):
        self.normal(self.actual_word)
        self.highlighted(f_word)

    def backward(self,f_mot):
        self.normal(self.actual_word)
        debut, fin = self.running_iter.backward_search(f_mot, gtk.TEXT_SEARCH_TEXT_ONLY, limit=None)
        self.running_iter = debut
        self.buffer1.apply_tag_by_name("fg_red",debut,fin)
        marquefin = self.buffer1.create_mark("fin",fin)
        self.my_textwidget.scroll_mark_onscreen(marquefin)
        self.buffer1.delete_mark(marquefin)
        self.actual_word = f_mot

    def test(self):

        i = self.word_list[self.n]
        print i
        for i in self.word_list:
            time.sleep(5)
            if self.n > 0:
                self.normal(self.word_list[self.n -1])
            self.highlighted(i)
            if self.n < self.word_number:
                self.n = self.n + 1

    def set_parameters(self,f_parameters):
        self.parameters = f_parameters
        self.set_tags()
        self.my_textwidget.modify_font(pango.FontDescription(self.parameters["wv_font"]))


    def set_tags(self):
        self.set_colors()
        self.tag1.set_property("font",self.parameters["wv_font"],                               )
        self.tag2.set_property("font",self.parameters["wv_font"])

#    def load_items(self,items):
#        for obj in items:
#            self.buffer1.insert_at_cursor (" ")
#            # on insère le texte
#            mamark = self.buffer1.get_insert()
#            debut_iter = self.buffer1.get_iter_at_mark(mamark)
#            self.buffer1.insert_with_tags_by_name(debut_iter,obj, "fg_bblue")
#            # on insère un blanc
#            self.buffer1.insert_at_cursor (" ")
#            yield True
#        self.highlighted(self.wordlist[0])
#        #treeview.set_model(liststore)
#        yield False

    def lazy_load_items(self,items):
        gobject.idle_add(self.load_items(items).next)

    def display_view(self,f_mode):
        # erase the buffer content
        start_text = self.buffer1.get_start_iter()
        end_text = self.buffer1.get_end_iter()
        self.buffer1.delete(start_text,end_text)
        if f_mode:
            self.my_textwidget.set_justification(gtk.JUSTIFY_CENTER)
        else:
            self.my_textwidget.set_justification(gtk.JUSTIFY_LEFT)
        for i in self.word_list:
            # un blanc
            self.buffer1.insert_at_cursor (" ")
            # on insère le texte
            mamark = self.buffer1.get_insert()
            debut_iter = self.buffer1.get_iter_at_mark(mamark)
            self.buffer1.insert_with_tags_by_name(debut_iter,i, "fg_bblue")
            # on insère un blanc ou un retour chariot
            if f_mode:
                self.buffer1.insert_at_cursor ("\n")
            else:
                self.buffer1.insert_at_cursor (" ")
        self.buffer1.insert_at_cursor("\n\n\n\n\n")
        #self.highlighted(self.word_list[0])
        self.startiter = self.buffer1.get_start_iter()
        self.running_iter = self.startiter.copy()
        self.highlighted(self.actual_word)
    
    def main(self):
        # setting the colors parameters
        self.set_colors()
        self.tag1 = self.buffer1.create_tag("fg_bblue",
                                foreground_gdk=self.color1,
                                background_gdk=self.color2,
                                font=self.parameters["wv_font"])
        self.tag2 = self.buffer1.create_tag("fg_red",
                                foreground_gdk=self.color3,
                                background_gdk=self.color4,
                                font=self.parameters["wv_font"])
        # don't know how to change the bacground property of the text widget ...
        self.my_textwidget.modify_font(pango.FontDescription(self.parameters["wv_font"]))
        self.word_number = len(self.word_list) -1
#        self.lazy_load_items(self.word_list)
        if len(self.word_list) > 0:
            self.actual_word = self.word_list[0]
        else:
            self.actual_word = ""
        self.display_view(False)
#        for i in self.word_list:
#            # un blanc
#            self.buffer1.insert_at_cursor (" ")
#            # on insère le texte
#            mamark = self.buffer1.get_insert()
#            debut_iter = self.buffer1.get_iter_at_mark(mamark)
#            self.buffer1.insert_with_tags_by_name(debut_iter,i, "fg_bblue")
#            # on insère un blanc ou un retour chariot
#            self.buffer1.insert_at_cursor (" ")
        # on ajoute des lignes vides pour le scrolling
#        self.buffer1.insert_at_cursor("\n\n\n\n\n")
#        #self.highlighted(self.word_list[0])
#        self.startiter = self.buffer1.get_start_iter()
#        self.running_iter = self.startiter.copy()
#        self.actual_word = ""



if __name__=="__main__":
    win = gtk.Window()
    win.resize(200,50)
    win.connect('delete-event',gtk.main_quit)
    # add here a test !
    win.show_all()
    gtk.main()
