#!/usr/bin/env python
# -*- coding: UTF-8 -*-

###############################################################################
#
#  Copyright (C) 2007 Eric Streit <Eric.Streit@wanadoo.fr>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
################################################################################

import os, sys, shutil

class Dirbase:
    """
    class responsible of creating the directories in the home
    directory: ~/.yazik  ~/.yazik/audio
    """

    def __init__(self):
        # dir creation
        my_dir = os.path.expanduser("~/.yazik/")
        my_audio_dir = os.path.join(my_dir,"audio")
        my_audio_tmp_dir = os.path.join(my_dir,"audio/tmp")
        if  not os.path.lexists(my_dir):
            try:
                os.mkdir(my_dir)
            except:
                print "Error: cannot create the home yazik dir"
        if not os.path.lexists(my_audio_dir):
            try:
                os.mkdir(my_audio_dir)
            except:
                print "Error: cannot create the audio dir"
        if not os.path.lexists(my_audio_tmp_dir):
            try:
                os.mkdir(my_audio_tmp_dir)
            except:
                print "Error: cannot create the audio tmp dir"
        # recorder conf file example, only if not yet here
        l_dir = os.path.dirname(__file__)
        recorder_conf_file = os.path.normpath(os.path.join (l_dir, "../recorder.conf"))
        #print "origine",recorder_conf_file
        home_recorder_conf_file = os.path.join (my_dir,"recorder.conf")
        #print "home",home_recorder_conf_file
        if os.path.lexists(home_recorder_conf_file):
            print "conf file exists: not overwriting"
        else:
            shutil.copyfile(recorder_conf_file,home_recorder_conf_file)
        # here add a example project file with the appropriate files ... maybe!


if __name__ == "__main__":
    my_dir_base = Dirbase()


