#!/usr/bin/env python
# -*- coding: UTF-8 -*-

###############################################################################
#
#  Copyright (C) 2007 Eric Streit <Eric.Streit@wanadoo.fr>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
################################################################################

import pygst
pygst.require("0.10")
import gst
import pygtk
# mandatory for installation with both pygtk1 and pygtk2
pygtk.require("2.0")
import gtk
import gtk.glade
import os, sys


class Infos:
    """
    this class is responsible of saving and loading the infos of the actual work (project):
    locutor infos, liste infos  and output infos
    """

    def __init__(self,f_glade):
        self.xml_glade = f_glade
        self.home_dir = os.path.expanduser("~")
        #print "home",self.home_dir
        self.yazik_dir = os.path.join(self.home_dir,".yazik/")
        #print "yazik", self.yazik_dir


    def save_locutor_infos(self):
        self.locutor_name = self.entry1.get_text()
        if self.locutor_name == "":
            self.locutor_name = "generic"
        self.locutor_living_town = self.entry2.get_text()
        self.locutor_living_country = self.entry7.get_text()
        self.locutor_gender = self.combobox4.get_active()
        self.locutor_year_of_birth = self.entry3.get_text()
        self.locutor_native_langage = self.entry8.get_text()
        self.locutor_linguistic_region = self.entry4.get_text()
        self.locutor_license = self.comboboxentry_entry1.get_text()
        self.locutor_copyright = self.entry5.get_text()
        self.locutor_langage_learning_country = self.entry10.get_text()
        locutor_filename = os.path.join(self.yazik_dir,self.locutor_name.replace(" ","_") + ".locu")
        #print locutor_filename
        try:
            l_file = open(locutor_filename,"w")
            l_file.write("locutor_name=" +  self.locutor_name + "\n")
            l_file.write("locutor_living_town=" +  self.locutor_living_town + "\n")
            l_file.write("locutor_living_country=" +  self.locutor_living_country + "\n")
            l_file.write("locutor_gender=" +  str(self.locutor_gender) + "\n")
            l_file.write("locutor_year_of_birth=" +  self.locutor_year_of_birth + "\n")
            l_file.write("locutor_native_langage=" +  self.locutor_native_langage + "\n")
            l_file.write("locutor_linguistic_region=" +  self.locutor_linguistic_region + "\n")
            l_file.write("locutor_license=" +  self.locutor_license + "\n")
            l_file.write("locutor_copyright=" + self.locutor_copyright  + "\n")
            l_file.write("locutor_langage_learning_country=" + self.locutor_langage_learning_country + "\n")
            l_file.close()
        except:
            print "error: cannot open file: ",locutor_filename, " for writing"

    def load_locutor_infos(self,f_file):
        locutor_filename = os.path.join(self.yazik_dir,self.locutor_name.replace(" ","_") + ".locu")
        #print "locutor",locutor_filename
        l_dic = {}
        try:
            l_file = open(locutor_filename,"r")
            for l in l_file:
                #print l
                (v,f) = l.split("=")
                #print v, "-",f
                l_dic[v] = f
                #print l_dic
            #print 0
            self.locutor_name = l_dic["locutor_name"].strip("\n\f\r")
            self.locutor_living_town = l_dic["locutor_living_town"].strip("\n\f\r")
            self.locutor_living_country = l_dic["locutor_living_country"].strip("\n\f\r")
            self.locutor_gender = int(l_dic["locutor_gender"].strip("\n\f\r"))
            self.locutor_year_of_birth = l_dic["locutor_year_of_birth"].strip("\n\f\r")
            self.locutor_native_langage = l_dic["locutor_native_langage"].strip("\n\f\r")
            self.locutor_linguistic_region = l_dic["locutor_linguistic_region"].strip("\n\f\r")
            self.locutor_license = l_dic["locutor_license"].strip("\n\f\r")
            self.locutor_copyright = l_dic["locutor_copyright"].strip("\n\f\r")
            self.locutor_langage_learning_country = l_dic["locutor_langage_learning_country"].strip("\n\f\r")
            #print 1
            # setting the values
            self.entry1.set_text(self.locutor_name)
            self.entry2.set_text(self.locutor_living_town)
            self.entry7.set_text(self.locutor_living_country)
            self.combobox4.set_active(self.locutor_gender)
            self.entry3.set_text(self.locutor_year_of_birth)
            self.entry8.set_text(self.locutor_native_langage)
            self.entry4.set_text(self.locutor_linguistic_region)
            self.comboboxentry_entry1.set_text(self.locutor_license)
            self.entry5.set_text(self.locutor_copyright)
            self.entry10.set_text(self.locutor_langage_learning_country)
            #print 1
        except:
            print "Error: unable to read the locutor file"


    def save_list(self):
        list_filename = os.path.join(self.audio_dir, self.list_name + ".txt")
        try:
            l_file = open(list_filename,"w")
            my_textbuffer = self.textview1.get_buffer()
            beginning = my_textbuffer.get_start_iter()
            ending = my_textbuffer.get_end_iter()
            l_text = my_textbuffer.get_text(beginning,ending) + "\n"
            l_file.write(l_text)
            l_file.close()
        except:
            print "error: cannot open file: ",list_filename, " for writing"
    
    def save_list_as(self,f_name):
        list_filename = f_name
        try:
            l_file = open(list_filename,"w")
            my_textbuffer = self.textview1.get_buffer()
            beginning = my_textbuffer.get_start_iter()
            ending = my_textbuffer.get_end_iter()
            l_text = my_textbuffer.get_text(beginning,ending) + "\n"
            l_file.write(l_text)
            l_file.close()
        except:
            print "error: cannot open file: ",list_filename, " for writing"
    
    def load_list(self,f_file):
        try:
            l_file = open(f_file,"r")
            #print 11
            buffer = self.textview1.get_buffer()
            #print 12
            beginning = buffer.get_start_iter()
            #print 13
            ending = buffer.get_end_iter()
            #print 14
            buffer.delete(beginning,ending)
            #print 22
            for line in l_file:
                #print line
                buffer.insert_at_cursor(line)
        except:
            print "error: unable to read the file: ",f_file



    def save_work_infos(self):
        self.locutor_name = self.entry1.get_text()
        self.list_langage = self.entry6.get_text()
        self.overwriting = repr(self.togglebutton1.get_active())
        self.audio_dir = self.filechooserbutton1.get_filename()
        self.name_style = self.combobox6.get_active() 
        self.flac = self.checkbutton1.get_active()
        self.ogg = self.checkbutton2.get_active()
        self.mp3 = self.checkbutton3.get_active()
        self.list_name = self.entry9.get_text()
        if self.list_name == "":
                self.list_name = "generic"
                self.audio_dir = os.path.join(self.yazik_dir,"audio")
        self.yazik_text = self.checkbutton4.get_active()
        self.yazik_tot = self.checkbutton5.get_active()
        self.shtooka_xml = self.checkbutton6.get_active()
        self.shtooka_txt = self.checkbutton7.get_active()
        #
        self.collection_description = self.entry11.get_text()
        self.short_collection_description = self.entry12.get_text()
        self.collection_section = self.entry13.get_text()
        self.collection_authors = self.entry14.get_text()
        self.quality = self.combobox1.get_active()
        self.speed = self.combobox2.get_active()
        #print self.audio_dir
        work_filename = os.path.join(self.yazik_dir,self.list_name + ".prj")
        #print "work file", work_filename
        try:
            l_file = open(work_filename,"w")
            l_file.write("locutor_name=" + self.locutor_name + "\n")
            l_file.write("list_langage=" + self.list_langage + "\n")
            l_file.write("overwriting=" + self.overwriting  + "\n")
            l_file.write("audio_dir=" + self.audio_dir  + "\n")
            l_file.write("name_style=" + str(self.name_style)  + "\n")
            l_file.write("flac=" +  repr(self.flac) + "\n")
            l_file.write("ogg=" +  repr(self.ogg) + "\n")
            l_file.write("mp3=" +  repr(self.mp3) + "\n")
            l_file.write("list_name=" + self.list_name  + "\n")
            l_file.write("yazik_text=" + repr(self.yazik_text)  + "\n")
            l_file.write("yazik_tot=" + repr(self.yazik_tot)  + "\n")
            l_file.write("shtooka_xml=" + repr(self.shtooka_xml)  + "\n")
            l_file.write("shtooka_txt=" + repr(self.shtooka_txt)  + "\n")
            #
            l_file.write("collection_description=" + self.collection_description  + "\n")
            l_file.write("short_collection_description=" + self.short_collection_description + "\n")
            l_file.write("collection_section=" + self.collection_section + "\n")
            l_file.write("collection_authors=" + self.collection_authors + "\n")
            l_file.write("quality=" + str(self.quality) + "\n")
            l_file.write("speed=" + str(self.speed) + "\n")
            l_file.close()
        except:
            print "error: cannot open file: ",work_filename, " for writing"


    def load_work_infos(self,f_file):
        self.project_file = f_file
        l_dic = {}
        try:
            l_file = open(self.project_file,"r")
            #print l_file
            for l in l_file:
                (v,f) = l.split("=")
                l_dic[v] = f
            self.locutor_name = l_dic["locutor_name"].strip("\n\f\r")
            self.list_langage = l_dic["list_langage"].strip("\n\f\r")
            self.overwriting = (l_dic["overwriting"].strip("\n\f\r")== "True")
            self.audio_dir = l_dic["audio_dir"].strip("\n\f\r")
            self.name_style = int(l_dic["name_style"].strip("\n\f\r")) 
            self.flac = (l_dic["flac"].strip("\n\f\r")=="True")
            self.ogg = (l_dic["ogg"].strip("\n\f\r")=="True")
            self.mp3 = (l_dic["mp3"].strip("\n\f\r")=="True")
            # DEBUG:
            print "flac:", self.flac,"ogg:",self.ogg,"mp3:",self.mp3
            print type(self.flac), type(self.ogg),type(self.mp3)
            self.list_name =l_dic["list_name"].strip("\n\f\r")
            self.yazik_text = (l_dic["yazik_text"].strip("\n\f\r")=="True")
            self.yazik_tot = (l_dic["yazik_tot"].strip("\n\f\r")=="True")
            self.shtooka_xml = (l_dic["shtooka_xml"].strip("\n\f\r")=="True")
            self.shtooka_txt = (l_dic["shtooka_txt"].strip("\n\f\r")=="True")
            #
            self.collection_description = l_dic["collection_description"].strip("\n\f\r")
            self.short_collection_description = l_dic["short_collection_description"].strip("\n\f\r")
            self.collection_section = l_dic["collection_section"].strip("\n\f\r")
            self.collection_authors = l_dic["collection_authors"].strip("\n\f\r")
            self.quality = int(l_dic["quality"].strip("\n\f\r"))
            self.speed = int(l_dic["speed"].strip("\n\f\r"))
            # setting the values
            self.entry1.set_text(self.locutor_name)
            self.entry6.set_text(self.list_langage)
            self.togglebutton1.set_active(self.overwriting)
            self.filechooserbutton1.set_filename(self.audio_dir)
            self.combobox6.set_active(self.name_style) 
            self.checkbutton1.set_active(self.flac)
            self.checkbutton2.set_active(self.ogg)
            self.checkbutton3.set_active(self.mp3 )
            self.entry9.set_text(self.list_name)
            self.checkbutton4.set_active(self.yazik_text)
            self.checkbutton5.set_active(self.yazik_tot)
            self.checkbutton6.set_active(self.shtooka_xml)
            self.checkbutton7.set_active(self.shtooka_txt)
            #
            self.entry11.set_text(self.collection_description)
            self.entry12.set_text(self.short_collection_description)
            self.entry13.set_text(self.collection_section)
            self.entry14.set_text(self.collection_authors)
            self.combobox1.set_active(self.quality)
            self.combobox2.set_active(self.speed)
        except:
            print "error: unable to read the project file"

    def save(self):
        # if some informations are not given, we don't save anything
        # or we can save in a generic name ?
        #print "saving ..."
        self.save_work_infos()
        self.save_list()
        self.save_locutor_infos()
        #print "end saving"


    def load(self,f_file):
        self.load_work_infos(f_file)
        #print 1
        list_filename = os.path.join(self.audio_dir, self.list_name + ".txt")
        #print 2
        self.load_list(list_filename)
        #print 3
        locutor_filename = os.path.join(self.audio_dir,self.locutor_name.replace(" ","_") + ".locu")
        #print 4
        self.load_locutor_infos(locutor_filename)
        #print 5

    def main(self):
        # the widgets
        # first page
        self.textview1 = self.xml_glade.get_widget("textview1")                      # words/phrases
        self.entry6 = self.xml_glade.get_widget("entry6")                            # langage
        self.togglebutton1 = self.xml_glade.get_widget("togglebutton1")              # overwriting
        # default value 
        self.overwriting = False 
        self.togglebutton1.set_active(self.overwriting)         
        # second page
        self.entry1 = self.xml_glade.get_widget("entry1")                            # name
        self.entry2 = self.xml_glade.get_widget("entry2")                            # living town
        self.entry7 = self.xml_glade.get_widget("entry7")                            # living country
        self.combobox4 = self.xml_glade.get_widget("combobox4")                      # gender
        self.entry3 = self.xml_glade.get_widget("entry3")                            # year of birth
        self.entry8 = self.xml_glade.get_widget("entry8")                            # native langage
        self.entry4 = self.xml_glade.get_widget("entry4")                            # linguistic region
        self.comboboxentry_entry1 = self.xml_glade.get_widget("comboboxentry-entry1")# license
        self.entry5 = self.xml_glade.get_widget("entry5")                            # copyright
        self.entry10 = self.xml_glade.get_widget("entry10")                          # where the locutor acquired the langage
        # third page
        self.audio_dir = os.path.join(self.yazik_dir,"audio")
        self.filechooserbutton1 = self.xml_glade.get_widget("filechooserbutton1")    # dir of audio files
        self.filechooserbutton1. set_current_folder(self.audio_dir)   
        self.combobox6 = self.xml_glade.get_widget("combobox6")                     # name style
        self.name_style = 0 
        self.combobox6.set_active(self.name_style)                    
        self.checkbutton1 = self.xml_glade.get_widget("checkbutton1")                # flac
        self.checkbutton2 = self.xml_glade.get_widget("checkbutton2")                # ogg
        self.checkbutton3 = self.xml_glade.get_widget("checkbutton3")                # mp3
        self.entry9 = self.xml_glade.get_widget("entry9")                            # list name
        self.checkbutton4 = self.xml_glade.get_widget("checkbutton4")                # yazik text
        self.checkbutton5 = self.xml_glade.get_widget("checkbutton5")                # yazik tot
        self.checkbutton6 = self.xml_glade.get_widget("checkbutton6")                # shtooka xml
        self.checkbutton7 = self.xml_glade.get_widget("checkbutton7")                # shtooka text
        self.entry11 = self. xml_glade.get_widget("entry11") 
        self.entry12 = self. xml_glade.get_widget("entry12")
        self.entry13 = self. xml_glade.get_widget("entry13")
        self.entry14 = self. xml_glade.get_widget("entry14")
        self.combobox1 = self.xml_glade.get_widget("combobox1")
        self.combobox2 = self.xml_glade.get_widget("combobox2")             
        self.list_name = "generic"
        
