#!/usr/bin/env python
# -*- coding: UTF-8 -*-

###############################################################################
#
#  Copyright (C) 2007 Eric Streit <Eric.Streit@wanadoo.fr>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
################################################################################

import pygtk
# mandatory for installation with both pygtk1 and pygtk2
pygtk.require("2.0")
import gtk
import gtk.glade
import os, sys

class Phrases:
    """
    this class is responsible of:
        cleaning the list of words/phrases
        importing various formats (xml, text)
        reading text files of words/phrases
    """

    def __init__(self, f_text_widget):
        self.text_widget = f_text_widget
        self.word_list = []

    def clean(self,f_list):
        l = []
        for f in f_list:
            #print f
            f = f.split("#")[0]
            f = f.rstrip("\n\f\r")
            f = f.strip()

            #print f
            if f != "":
                l.append(f)
        return l


    def read_file(self,f_filename,f_buffer):
        # here: 2 solutions: add the new file or replace the old one
        message = gtk.MessageDialog(None, gtk.DIALOG_MODAL, gtk.MESSAGE_INFO, gtk.BUTTONS_YES_NO, \
                                    "Do you want the new list to be added \n  to the actual one?")
        resp = message.run()
        my_textbuffer = self.text_widget.get_buffer()
        beginning = my_textbuffer.get_start_iter()
        ending = my_textbuffer.get_end_iter()
        if resp == gtk.RESPONSE_YES:
            #print "OK!!!!!!"
            # we test if we ended with an end of line at the end of the text
            l = self.get_list()
            n = len(l)
            if my_textbuffer.get_line_count()== n:
                my_textbuffer.insert(ending,"\n")
        else:
            #print "NO!!!!!"
            my_textbuffer.delete(beginning,ending)
        try:
            f = open(f_filename,"r")
            for line in f:
                f_buffer.insert_at_cursor(line)
        except:
            print "error: unable to read the file"
        message.destroy()

    def import_file(self):
        pass

    def get_list(self):
        my_textbuffer = self.text_widget.get_buffer()
        beginning = my_textbuffer.get_start_iter()
        ending = my_textbuffer.get_end_iter()
        l_list = []
        l_list = my_textbuffer.get_text(beginning,ending).split("\n")
        #print "l_list", l_list
        self.word_list = self.clean(l_list)
        #print "word_list",self.word_list
        return self.word_list


