#!/usr/bin/env python
# -*- coding: UTF-8 -*-

###############################################################################
#
#  Copyright (C) 2007 Eric Streit <Eric.Streit@wanadoo.fr>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
################################################################################

import pygst
pygst.require("0.10")
import gst
import pygtk
# mandatory for installation with both pygtk1 and pygtk2
pygtk.require("2.0")
import gtk
import gobject
import gtk.glade
import os, sys, glob, time, glob, urllib

import recorder
from recorder import recorder

import phrases, infos, dirbase

import name
from name import  name
import langage
from langage import langage
import country
from country import country
import audiofiles
from audiofiles import audiofiles



the_button = None
the_player = None

def OnEOS(bus, message):
        """
        Called when the preview stream ends. It deactives the AudioPreview.
        
        Parameters:
            bus -- reserved for GStreamer callbacks, dont't use it explicitly.
            message -- reserved for GStreamer callbacks, dont't use it explicitly.
        """
        
        global the_button,the_player
        
        the_button.set_sensitive(True)
        the_player.set_state(gst.STATE_NULL)
        the_player = None
 
 
        
def listen_audio_file(f_widget,f_filename):
    global the_button,the_player
    try:
        the_button = f_widget
        print "button", the_button
        the_button.set_sensitive(False)
    #        the_player = gst.element_factory_make("playbin", "player")
        b = os.path.basename(f_filename)
        ext = b.split(".")[1] 
        if ext == "flac":
            the_player = gst.Pipeline("mypipeline")
            filesrc = gst.element_factory_make("filesrc", "audio")
            the_player.add(filesrc)        
            decoder =  gst.element_factory_make("flacdec","decoder")
            the_player.add(decoder) 
            sink = gst.element_factory_make("alsasink", "sink")
            the_player.add(sink)
            filesrc.link(decoder)
            decoder.link(sink)
            bus = the_player.get_bus()
            bus.add_signal_watch()
            # deactivate thyself if the sound finishes or there's an error
            bus.connect("message::eos", OnEOS)
            bus.connect("message::error", OnEOS)
            uri = "file://" + f_filename
            print 'Playing:', uri
            #the_player.set_property('uri', uri)
            filesrc.set_property("location",f_filename)
            the_player.set_state(gst.STATE_PLAYING)
        else:
            the_player = gst.element_factory_make("playbin", "player")    
            bus = the_player.get_bus()
            bus.add_signal_watch()
            # deactivate thyself if the sound finishes or there's an error
            bus.connect("message::eos", OnEOS)
            bus.connect("message::error", OnEOS)
            uri = "file://" + f_filename
            print 'Playing:', uri
            the_player.set_property('uri', uri)
            the_player.set_state(gst.STATE_PLAYING)
    except:
        print "Error playing the file: ", f_filename

                
class Yrecorder:

    TARGET_TYPE_URI_LIST = 80
    dnd_list = [ ( 'text/uri-list', 0, TARGET_TYPE_URI_LIST ) ]

    def __init__(self,f_application):
        self.application = f_application
        l_dir = os.path.dirname(__file__)
        l_file_name = os.path.join (l_dir, "wikirecorder.glade")
        # DEBUG:
        #print l_file_name
        self.xml_glade = gtk.glade.XML(fname=l_file_name,domain=self.application)
        self.main_window = self.xml_glade.get_widget("window1")
        dic={"on_window1_delete_event"            : self.on_window1_delete,
             "on_window1_destroy"                 : self.on_window1_destroy,
             "on_toolitem1_clicked"               : self.on_toolitem1_clicked,
             "on_toolitem5_clicked"               : self.on_toolitem5_clicked,
             "on_toolitem3_clicked"               : self.on_toolitem3_clicked,
             "on_toolitem2_clicked"               : self.on_toolitem2_clicked,
             "on_toolitem6_clicked"               : self.on_toolitem6_clicked,
             "on_button2_clicked"                 : self.on_button2_clicked,
             "on_button1_clicked"                 : self.on_button1_clicked,
             # dialog buttons
              "on_button4_clicked"                 : self.on_button4_clicked,
              "on_button3_clicked"                 : self.on_button3_clicked,
              "on_button7_clicked"                 : self.on_button7_clicked,
              "on_button11_clicked"                : self.on_button11_clicked,
             #
             "on_button5_clicked"                 : self.on_button5_clicked,
             "on_button6_clicked"                 : self.on_button6_clicked,
             # button 8 rdirected to signal 6
             "on_button8_clicked"                 : self.on_button8_clicked,
             "on_button9_clicked"                 : self.on_button9_clicked,
             "on_button10_clicked"                : self.on_button10_clicked,
             "on_toolitem4_clicked"                : self.on_toolitem4_clicked,
             "on_entry6_editing_done"             : self.on_entry6_editing_done,
             "on_entry7_editing_done"             : self.on_entry7_editing_done,
             "on_entry8_editing_done"             : self.on_entry8_editing_done,
             "on_togglebutton1_toggled"           : self.on_togglebutton1_toggled,
             "on_entry1_focus_in_event"           : self.on_entry1_focus_in_event,
             "on_entry6_focus_in_event"           : self.on_entry6_focus_in_event,
             "on_entry7_focus_in_event"           : self.on_entry7_focus_in_event,
             "on_entry8_focus_in_event"           : self.on_entry8_focus_in_event,
             "on_entry1_activate"                 : self.on_entry1_activate,
             "on_entry1_editing_done"             : self.on_entry1_activate,
#             "on_entry10_activate"                : self.on_entry10_activate,
             "on_entry10_focus_in_event"          : self.on_entry10_focus_in_event,
             "on_entry10_editing_done"            : self.on_entry10_editing_done,
             #"on_button12_clicked"                : self.on_button12_clicked,
             #"on_textview1_key_press_event"       : self.on_textview1_key_press_event,
             "on_textview2_button_press_event"    : self.on_textview2_button_press_event,
             "on_textview3_button_press_event"    : self.on_textview3_button_press_event,
             "on_imagemenuitem1_activate"         : self.on_toolitem3_clicked,
             "on_imagemenuitem2_activate"         : self.on_toolitem1_clicked,
             "on_imagemenuitem3_activate"         : self.on_imagemenuitem3_activate,
             "on_imagemenuitem4_activate"         : self.on_imagemenuitem4_activate,
             "on_imagemenuitem5_activate"         : self.on_imagemenuitem5_activate,
             "on_menuitem6_activate"              : self.on_toolitem4_clicked,
             "on_menuitem7_activate"              : self.on_toolitem5_clicked,
             "on_menuitem8_activate"              : self.on_menuitem8_activate,
             "on_menuitem9_activate"              : self.on_menuitem9_activate,
             "on_imagemenuitem10_activate"        : self.on_imagemenuitem10_activate,
             "on_menuitem11_activate"             : self.on_menuitem11_activate,
             "on_menuitem12_activate"             : self.on_menuitem12_activate,
             "on_textview1_drag_data_received"    : self.on_textview1_drag_data_received,
             "on_window3_delete_event"            : self.on_window3_delete_event,
             "on_window3.destroy"                 : self.on_window3_destroy,
             "on_treeview1_button_press_event"    : self.on_treeview1_button_press_event,
             "on_treeview2_button_press_event"    : self.on_treeview2_button_press_event,
             "on_treeview3_button_press_event"    : self.on_treeview2_button_press_event,
             "on_toolbutton3_clicked"             : self.on_toolbutton3_clicked,
             "on_toolbutton6_clicked"             : self.on_toolbutton6_clicked,
             "on_toolbutton7_clicked"             : self.on_toolbutton7_clicked,
             "on_toolbutton8_clicked"             : self.on_toolbutton8_clicked,
             "on_toolbutton4_clicked"             : self.on_toolbutton4_clicked,
             "on_toolbutton13_clicked"             : self.on_toolbutton13_clicked,
             #textview cut and paste
             "on_textview1_copy_clipboard"        : self.on_textview1_copy_clipboard,
             "on_textview1_cut_clipboard"        : self.on_textview1_cut_clipboard,
             "on_textview1_paste_clipboard"        : self.on_textview1_paste_clipboard,
             "on_textview1_select_all"             : self.on_textview1_select_all
             }
        self.xml_glade.signal_autoconnect(dic)
        #####################################################

    def get_file_path_from_dnd_dropped_uri(self,uri):
        path = urllib.url2pathname(uri) # escape special char
        path = path.strip('\r\n\x00') # remove \r\n and NULL
    
        # get the path to file
        if path.startswith('file:\\\\\\'): # windows
            path = path[8:] # 8 is len('file:///')
        elif path.startswith('file://'): # nautilus, rox
            path = path[7:] # 7 is len('file://')
        elif path.startswith('file:'): # xffm
            path = path[5:] # 5 is len('file:')
        return path
    
    def on_textview1_drag_data_received(self,widget, context, x, y, selection, target_type, timestamp):
        if target_type == self.TARGET_TYPE_URI_LIST:
            uri = selection.data.strip()
            print 'uri', uri
            uri_splitted = uri.split() # we may have more than one file dropped
            for uri in uri_splitted:
                path = self.get_file_path_from_dnd_dropped_uri(uri)
                print 'path to open', path
                if os.path.isfile(path): # is it file?
                    data = file(path).read()
                    #print data
                    widget.get_buffer().set_text(data)
#############################################

    def read_file(self,f_filename):
        buffer = self.text_widget.get_buffer()
        self.my_phrases.read_file(f_filename,buffer)
#############################################
    # textview1 cut and paste functions
    
    def on_textview1_copy_clipboard(self,obj):
        print "copy"
        self.textview1_buffer.copy_clipboard(self.clipboard)
        
    def on_textview1_cut_clipboard(self,obj):
        print "cut"
        self.textview1_buffer.cut_clipboard(self.clipboard,True) 
           
    def on_textview1_paste_clipboard(self,obj):
        print "paste"
        self.textview1_buffer.paste_clipboard(self.clipboard)
        
    def on_textview1_select_all(self,obj):
        #self.textview1_buffer.copy_clipboard(self.clipboard)
        pass

#############################################

    def on_toolitem1_clicked(self,widget,data=None):
        # DEBUG: open text button
        #print "on_toolitem1_clicked: open"
        filename = ""
        chooser = gtk.FileChooserDialog("Choose the file with list of words/phrases",
                                        None,
                                        gtk.FILE_CHOOSER_ACTION_OPEN,
                                        (gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN,gtk.RESPONSE_OK))
        filter = gtk.FileFilter()
        filter.set_name("Text files")
        chooser.add_filter(filter)
        filter.add_mime_type("txt")
        filter.add_pattern("*.txt")
        response = chooser.run()
        if response == gtk.RESPONSE_OK:
            filename = chooser.get_filename()
            #print filename
            # now: populate the text widget
            self.read_file(filename)
            self.update_word_dic()
            self.set_button_activ(True)
        elif response == gtk.RESPONSE_CANCEL:
            print "closed without choosing"
        chooser.destroy()

    def on_imagemenuitem4_activate(self,widget,data=None):
        # save the list under another name
        l_name = ""
        l_file_selector = gtk.FileChooserDialog("Selecting the name of the list for saving",
                                        None,
                                        gtk.FILE_CHOOSER_ACTION_SAVE,
                                        (gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN,gtk.RESPONSE_OK))
        filter = gtk.FileFilter()
        filter.set_name("Text files" )
        l_file_selector.add_filter(filter)
        filter.add_mime_type("/archive/txt")
        filter.add_pattern("*.txt")
        response = l_file_selector.run()
        if response == gtk.RESPONSE_OK:
            l_name = l_file_selector.get_filename()
            print l_name
        elif response == gtk.RESPONSE_CANCEL:
            print "You havn't coose any file name  ..."
            l_name = ""
        l_file_selector.destroy()
        self.my_infos.save_list_as(l_name)

    def on_toolitem5_clicked(self,widget,data=None):
        # DEBUG: project saving button
        print "on toolitem 5 clicked: project saving"
        self.my_infos.save()
        self.my_project_open = True


    def on_toolitem3_clicked(self,widget,data=None):
        # DEBUG: new
        #print "on_toolitem3_clicked: new"
        buffer = self.xml_glade.get_widget("textview1").get_buffer()
        beginning = buffer.get_start_iter()
        ending = buffer.get_end_iter()
        buffer.delete(beginning,ending)
        self.set_button_activ(False)


    def on_toolitem2_clicked(self,widget,data=None):
        # DEBUG: import 
        print "on toolitem 2 clicked: import"
        message = gtk.MessageDialog(None, gtk.DIALOG_MODAL, gtk.MESSAGE_INFO, gtk.BUTTONS_OK, "Not yet implemented")
        #message.add_button(gtk.STOCK_QUIT, gtk.RESPONSE_CLOSE)
        resp = message.run()
        if resp == gtk.RESPONSE_OK:
            message.destroy()

    def generate(self):
        self.my_infos.save()
        self.my_project_open = True
        # testing if some important informations are present
        #    langage, living country, country were the speaker acquired the 
        #        langage
        #    as all of these are necessary to name the audio files.
        if (self.my_infos.list_langage == "") or (self.my_infos.locutor_langage_learning_country == "" ):
            message = gtk.MessageDialog(None, gtk.DIALOG_MODAL, gtk.MESSAGE_INFO, gtk.BUTTONS_OK,"Please, enter the langage informations first\n and come back later")
            resp = message.run()
            message.destroy()
            return
        self.update_word_dic()
        # testing if some audio files exist
        no_audio = True
        print self.word_dic
        for k in self.word_dic.keys():
            print self.word_dic[k], self.word_dic[k][1]
            if self.word_dic[k][1] == 1:
                no_audio = False
                break
        if no_audio:
            print "no audio files"
            # TODO:
            # maybe here a message ?
            message = gtk.MessageDialog(None, gtk.DIALOG_MODAL, gtk.MESSAGE_INFO, gtk.BUTTONS_OK, "No audio files yet recorded")
            #message.add_button(gtk.STOCK_QUIT, gtk.RESPONSE_CLOSE)
            resp = message.run()
            if resp == gtk.RESPONSE_OK:
                message.destroy()
            return
        # testing the name of the list (generic or not)
        if self.my_infos.list_name == "generic":
            print "generic name ..."
            message = gtk.MessageDialog(None, gtk.DIALOG_MODAL, gtk.MESSAGE_INFO, gtk.BUTTONS_YES_NO, "Confirm use of 'generic' list name")
            #message.add_button(gtk.STOCK_QUIT, gtk.RESPONSE_CLOSE)
            resp = message.run()
            if resp == gtk.RESPONSE_YES:
                message.destroy()
            else:
                return
            # put here a message dialog
        # TODO: asking if not all words were recorded
        # launching the generation of audio files
        l_widget = self.xml_glade.get_widget("toolitem6")
        l_widget.set_sensitive(False)
        print "yrecorder infos:", type (self.my_infos.mp3)
        audiofiles.LaunchAudiofiles(self.my_infos, self.word_dic,l_widget,self.application)
        

    def on_toolitem6_clicked(self,widget,data=None):
        # DEBUG: generate 
        print "on toolitem 6 clicked: generate"
        # saving and updating the infos about the audio filesprint "yrecorder infos:", type (self.my_infos.mp3)
        self.get_recorded()
        self.generate()

    def on_toolbutton3_clicked(self,widget,data=None):
        print "on toolbutton3 clicked : listen"
        l_content = self.treeview1.get_model()[self.l_iter][2]
        print l_content
        self.play_sound(l_content)
        
        
    def on_toolbutton6_clicked(self,widget,data=None):
        print "on toolbutton6 clicked: listen all"
#        self.l_iter = self.model_treeview1.get_iter_root()
#        l_content = self.model_treeview1[self.l_iter][1]
#        print l_content
#        self.play_sound(l_content)
#        iter_temp = self.l_iter
#        self.l_iter = self.model_treeview1.iter_next(self.l_iter)
#        while self.l_iter != None:
#            # mise à jour de l'affichage ...
#            treeselection = self.treeview1.get_selection()
#            treeselection.select_iter(self.l_iter)
#            l_content = self.model_treeview1[self.l_iter][1]
#            print l_content
#            self.play_sound(l_content)
#            self.l_iter = self.model_treeview1.iter_next(self.l_iter)
#        else:
#            self.l_iter = iter_temp
            
    def on_toolbutton7_clicked(self,widget,data=None):
        print "on toolbutton7 clicked : prev"
        l_path = self.treeview1.get_model().get_path(self.l_iter)
        l_path_int = l_path[0]
        if l_path_int > 0:
            l_path_int = l_path_int -1
            self.l_iter = self.treeview1.get_model().get_iter(l_path_int)
            self.treeselection = self.treeview1.get_selection()
            self.treeselection.select_iter(self.l_iter)
            #l_contenu = self.model_treeview1[self.l_iter][0]
            self.model_treeview2.clear()
            self.model_treeview3.clear()
            self.display_tags(self.l_iter)
            
    def on_toolbutton8_clicked(self,widget,data=None):
        print "on toolbutton8 clicked : next"
        # we get the iter
        # we test if we are not at the end        
        iter_temp = self.l_iter
        self.l_iter = self.treeview1.get_model().iter_next(self.l_iter)
        if self.l_iter != None:
            # mise à jour de l'affichage ...
            self.treeselection = self.treeview1.get_selection()
            self.treeselection.select_iter(self.l_iter)
        else:
            self.l_iter = iter_temp
        self.model_treeview2.clear()
        self.model_treeview3.clear()
        self.display_tags(self.l_iter)
    
        
    def on_toolbutton4_clicked(self,widget,data=None):
        print "on toolbutton4 clicked"
        if self.have_to_generate:
            self.want_to("The tags were modified. \n\n Do you want to save the modifications \n in the index and the audio files?")
        self.audiolist.hide()
    
    def on_toolbutton13_clicked(self,widget,data=None):
        print "Erasing the taggued files"
        message = gtk.MessageDialog(None, gtk.DIALOG_MODAL, gtk.MESSAGE_WARNING, gtk.BUTTONS_YES_NO, \
                                    "Do you really want do delete the marked files?")
        resp = message.run()
        message.destroy()
        if resp == gtk.RESPONSE_YES:
            #os.remove(filename)
            print "removing files"
            self.remove_marked_files()
    
    # dialog callbacks
    def on_button3_clicked(self,widget,data=None):
        print "on button 3 clicked"
        self.xml_glade.get_widget(self.langage_entry).set_text(self.the_entry)
        self.dialog1.hide()
        
    def on_button4_clicked(self,widget,data=None):
        print "on button 4 clicked"
        
    def on_button7_clicked(self,widget,data=None):
        print "on button 7 clicked"
        self.xml_glade.get_widget("entry7").set_text(self.the_entry)
        self.dialog2.hide()
        
    def on_button11_clicked(self,widget,data=None):
        print "on button 11 clicked"
        

    def on_button5_clicked(self,widget,data=None):
        # DEBUG: record
        #print "on button 5 clicked: record"
        # first, we get the words/phrases from he text widget
        # second, we launch the recorder with this list as parameter
        # the third is the overwriting mode
        #self.ph = self.my_phrases.get_list()
        self.my_infos.save()
        self.my_project_open = True
        self.update_word_dic()
        ph = []
        l_dic = {}
        for i in self.word_dic.keys():
            
            if self.overwriting:
                #ph.append(self.word_dic[i][0])
                l_dic[self.word_dic[i][2]]=self.word_dic[i][0]
            else:
                if self.word_dic[i][1] != 1:
                    #ph.append(self.word_dic[i][0])
                    l_dic[self.word_dic[i][2]]=self.word_dic[i][0]
        #print "ph",ph
        ll = l_dic.keys()
        ll.sort()
       #print "ll",ll
        for i in ll:
            ph.append(l_dic[i])
        #print "ph",ph
        rec = recorder.LaunchRecorder (
            ph,
            os.path.join(self.my_infos.audio_dir,"tmp"),self)
        self.to_be_updated = True


    def on_button6_clicked(self,widget,data=None):
        # DEBUG: information language
        #print "on button 6 clicked: information"
        # double clic on a ligne select the info and close the dialog
        self.dialog1 = self.xml_glade.get_widget("dialog1")
        self.langage_entry = "entry6"
        self.dialog1.show()
        
    def on_button8_clicked(self,widget,data=None):
        # DEBUG: information language
        #print "on button 8 clicked: information"
        # double clic on a ligne select the info and close the dialog
        self.dialog1 = self.xml_glade.get_widget("dialog1")
        self.langage_entry = "entry8"
        self.dialog1.show()

    def on_button2_clicked(self,widget,data=None):
        # DEBUG: information language
        #print "on button 2 clicked: information"
        # double clic on a ligne select the info and close the dialog
        self.dialog2 = self.xml_glade.get_widget("dialog2")
        self.country_entry = "entry7"
        self.dialog2.show()
        
    def on_button1_clicked(self,widget,data=None):
        # DEBUG: information language
        #print "on button  clicked: information"
        # double clic on a ligne select the info and close the dialog
        self.dialog2 = self.xml_glade.get_widget("dialog2")
        self.country_entry = "entry10"
        self.dialog2.show()

    def on_button9_clicked(self,widget,data=None):
        #print "on button 9 clicked"
        self.dialog1.hide()

    def on_button10_clicked(self,widget,data=None):
        #print "on button 10 clicked"
        self.dialog2.hide()

    def on_toolitem4_clicked(self,widget,data=None):
        #print "on button 11 clicked"
        filename = ""
        chooser = gtk.FileChooserDialog("Choose the project file",
                                        None,
                                        gtk.FILE_CHOOSER_ACTION_OPEN,
                                        (gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN,gtk.RESPONSE_OK))
        filter = gtk.FileFilter()
        filter.set_name("Project files")
        chooser.add_filter(filter)
        filter.add_mime_type("prj")
        filter.add_pattern("*.prj")
        chooser.set_current_folder(os.path.expanduser("~/.yazik"))
        response = chooser.run()
        if response == gtk.RESPONSE_OK:
            filename = chooser.get_filename()
            #print filename
        elif response == gtk.RESPONSE_CANCEL:
            print "closed without choosing"
        chooser.destroy()
        if filename != "":
            self.my_infos.load(filename)
            self.get_recorded()
            self.update_word_dic()
            self.my_project_open = True
            self.overwriting = self.my_infos.overwriting
            b = self.xml_glade.get_widget("togglebutton1")
            b.set_active(self.overwriting)
            self.set_button_activ(True)
            if self.overwriting:
                b.set_label("Overwriting all")
            else:
                b.set_label("Adding new only")


    def on_button12_clicked(self,widget,data=None):
#        if self.to_be_updated:
#            self.get_recorded()
        self.update_word_dic()

        
    def on_imagemenuitem3_activate(self,widget,data=None):
        print "on_imagemenuitem4_activate"
        self.my_infos.save_list()
        
    def on_imagemenuitem5_activate(self,widget,data=None):
        print "on_imagemenuitem5_activate"
        gtk.main_quit()
        
    def on_menuitem8_activate(self,widget,data=None):
        print "on_imagemenuitem8_activate"
        # project saving under another name
        
        
    def on_menuitem9_activate(self,widget,data=None):
        print "on_imagemenuitem9_activate"
        # help
        message = gtk.MessageDialog(None, gtk.DIALOG_MODAL, gtk.MESSAGE_INFO, gtk.BUTTONS_CLOSE, \
                                        "Please, visit the website: http://www.yojik.eu/ ")
        resp = message.run()
        message.destroy()
        return
        
        
    def on_imagemenuitem10_activate(self,widget,data=None):
        print "on_imagemenuitem10_activate: audiolist"
        self.about = self.xml_glade.get_widget("aboutdialog1")
 #      rajouter ici le logo à trouver ....
        self.about.run()
        
     
     
    def remove_marked_files(self):
        #collecting the files to remove
        remove_list = []
        treeiter = self.model_treeview1_tmp.get_iter_first()
        while treeiter:
            n = os.path.join(self.tmp_dir,  self.model_treeview1_tmp.get_value(treeiter,2)) + ".flac"
            print self.model_treeview1_tmp.get_value(treeiter,0), "**",n
            if self.model_treeview1_tmp.get_value(treeiter,0):
                remove_list.append(n)
                self.model_treeview1_tmp.remove(treeiter)
            treeiter = self.model_treeview1_tmp.iter_next(treeiter)
        #    
        treeiter = self.model_treeview1_flac.get_iter_first()
        while treeiter:
            flac_file = self.my_naming_class.get( self.model_treeview1_flac.get_value(treeiter,1),self.my_infos.list_langage,self.my_infos.locutor_langage_learning_country) + ".flac"
            n = os.path.join(self.flac_dir,  flac_file)
            print self.model_treeview1_flac.get_value(treeiter,0), "**",n
            if self.model_treeview1_flac.get_value(treeiter,0):
                remove_list.append(n)
                self.model_treeview1_flac.remove(treeiter)
            treeiter = self.model_treeview1_flac.iter_next(treeiter)    
        #
        treeiter = self.model_treeview1_ogg.get_iter_first()
        while treeiter:
            ogg_file = self.my_naming_class.get(self.model_treeview1_ogg.get_value(treeiter,1),self.my_infos.list_langage,self.my_infos.locutor_langage_learning_country) + ".ogg"
            n = os.path.join(self.ogg_dir,  ogg_file)
            print self.model_treeview1_ogg.get_value(treeiter,0), "**",n
            if self.model_treeview1_ogg.get_value(treeiter,0):
                remove_list.append(n)
                self.model_treeview1_ogg.remove(treeiter)
            treeiter = self.model_treeview1_ogg.iter_next(treeiter)    
        #
        treeiter = self.model_treeview1_mp3.get_iter_first()
        while treeiter:
            mp3_file = self.my_naming_class.get(self.model_treeview1_mp3.get_value(treeiter,1),self.my_infos.list_langage,self.my_infos.locutor_langage_learning_country) + ".mp3"
            n = os.path.join(self.mp3_dir,  mp3_file)
            print self.model_treeview1_mp3.get_value(treeiter,0), "**",n
            if self.model_treeview1_mp3.get_value(treeiter,0):
                remove_list.append(n)
                self.model_treeview1_mp3.remove(treeiter)
            treeiter = self.model_treeview1_mp3.iter_next(treeiter)    
        #
        print remove_list
        for i in remove_list:
                os.remove(i)
        self.to_be_updated = True
        self.update_word_dic()
        
        
        
    def populate_window3(self):
        # clean
        self.model_treeview1_tmp.clear()
        self.model_treeview1_flac.clear()
        self.model_treeview1_ogg.clear()
        self.model_treeview1_mp3.clear()
        if self.my_infos.name_style == 0:
            self.my_naming_class =  name.YazikName()
            print "yazik name"
        elif self.my_infos.name_style == 1:
            self.my_naming_class =  name.WikiDictionnaryName()
            print "wiki name"
        elif self.my_infos.name_style == 2:
            self.my_naming_class =  name.ShtookaName()
            print "shtooka name"   
        else:
            self.my_naming_class = name.CRC32Name() 
        #self.model_treeview1.clear()
        self.treeselection = self.treeview1.get_selection()
        self.model_treeview2.clear()
        # populate with values
        self.home_dir = os.path.expanduser("~")
        self.yazik_dir = os.path.join(self.home_dir,".yazik/")
        self.data_dir = os.path.join(self.yazik_dir,"data")
        self.audio_dir = os.path.join(self.yazik_dir,"audio")
        self.list_dir = os.path.join(self.data_dir, self.my_infos.list_name)
        self.flac_dir = os.path.join(self.list_dir,"flac")
        self.tmp_dir = os.path.join( self.audio_dir, "tmp")
        self.ogg_dir = os.path.join(self.list_dir,"ogg")
        self.mp3_dir = os.path.join(self.list_dir,"mp3")
        list_filename = os.path.join(self.audio_dir,self.my_infos.list_name +".index.txt")
        tot_filename = os.path.join(self.audio_dir,self.my_infos.list_name +".tot.txt")
        print list_filename, tot_filename
        self.treeview1.set_model(self.model_treeview1_tmp)
        self.my_connect_id = self.renderer0.connect( 'toggled', self.col0_toggled_cb, self.treeview1.get_model())
        #try:
        self.dico_tot = {}
        f0 = open(tot_filename,"r")
        for ff in f0:
            ff = ff.strip("\n\f\r")
            if ff != "":
                fff = ff.split("=")
                self.dico_tot[fff[0]] = fff[1]
        f0.close()
        self.dico_files = {}
        f1 = open(list_filename,"r")
        for l in f1:
            l = l.strip("\n\f\r")
            if l != "":
                ll = l.split("::")
                self.dico_files[ll[0]]= [ ll[1],ll[2],  ll[3] ]
                ogg_file = self.my_naming_class.get(ll[1],self.my_infos.list_langage,self.my_infos.locutor_langage_learning_country) + ".ogg"
                flac_file = self.my_naming_class.get(ll[1],self.my_infos.list_langage,self.my_infos.locutor_langage_learning_country) + ".flac"
                mp3_file = self.my_naming_class.get(ll[1],self.my_infos.list_langage,self.my_infos.locutor_langage_learning_country) + ".mp3"
                print "ogg file:" , ogg_file
                if os.path.lexists(os.path.join(self.tmp_dir, ll[0] + ".flac")):
                    self.model_treeview1_tmp.append([False,ll[1],ll[0]])
                    #self.treeview1.set_model(self.model_treeview1_tmp)
                if os.path.lexists(os.path.join(self.flac_dir, flac_file)):
                    self.model_treeview1_flac.append([False,ll[1],ll[0]])
                    #self.treeview1.set_model(self.model_treeview1_tmp)
                if os.path.lexists(os.path.join(self.ogg_dir, ogg_file)):
                    self.model_treeview1_ogg.append([False,ll[1],ll[0]])
                    #self.treeview1.set_model(self.model_treeview1_tmp)
                if os.path.lexists(os.path.join(self.mp3_dir, mp3_file)):
                    self.model_treeview1_mp3.append([False,ll[1],ll[0]])
                    #self.treeview1.set_model(self.model_treeview1_tmp)
        f1.close() 
        self.l_iter = self.treeview1.get_model().get_iter_root() 
        if self.l_iter != None:
            self.treeselection.select_iter(self.l_iter)
            print "self.l_iter", self.l_iter  
            self.display_tags(self.l_iter)   
        #except:
           # print "Error loading: ", list_filename
    
    
    def play_sound(self,f_content):
        if self.my_infos.name_style == 0:
            self.my_naming_class =  name.YazikName()
        elif self.my_infos.name_style == 1:
            self.my_naming_class =  name.WikiDictionnaryName()
        elif self.my_infos.name_style == 2:
            self.my_naming_class =  name.ShtookaName()   
        else:
            self.my_naming_class = name.CRC32Name() 
        if self.toggle_audio == "flac":
            flac_dir = os.path.join(self.list_dir,"flac")
            n = self.my_naming_class.get(self.treeview1.get_model()[self.l_iter][1],self.my_infos.list_langage,self.my_infos.locutor_langage_learning_country) + ".flac"
            print n
            l_filename = os.path.join(flac_dir,n)
            #listen_audio_file(os.path.join(flac_dir,n))
        if self.toggle_audio == "ogg": 
            ogg_dir = os.path.join(self.list_dir,"ogg")
            n = self.my_naming_class.get(self.treeview1.get_model()[self.l_iter][1],self.my_infos.list_langage,self.my_infos.locutor_langage_learning_country) + ".ogg"
            print n
            l_filename = os.path.join(ogg_dir,n)
            #listen_audio_file(os.path.join(ogg_dir,n)) 
        if self.toggle_audio == "mp3":
            mp3_dir = os.path.join(self.list_dir,"mp3")
            n = self.my_naming_class.get(self.treeview1.get_model()[self.l_iter][1],self.my_infos.list_langage,self.my_infos.locutor_langage_learning_country) + ".mp3"
            print n
            l_filename = os.path.join(mp3_dir,n)
            #listen_audio_file(os.path.join(mp3_dir,n))
        if self.toggle_audio == "tmp":
            tmp_dir = os.path.join(self.yazik_dir, "audio/tmp/")
            l_filename = os.path.join(tmp_dir,f_content + ".flac")
            print "tmp", l_filename
        listen_audio_file(self.listen_widget,l_filename)
   
    
    def display_tags(self,f_iter):
            l_content = self.treeview1.get_model()[f_iter][2]
            print l_content
            # populate the commons infos
            for i in self.dico_tot.keys():
                self.model_treeview2.append([i ,self.dico_tot[i]])
            # print self.dico_files.keys()
            l = self.dico_files[l_content]
            # print l                                
            self.model_treeview3.prepend(["SWAC_TECH_DATE",l[2]])
            self.model_treeview3.prepend(["TITLE",l[1] ])
            self.model_treeview3.prepend(["SWAC_TEXT",l[0]])
        
    def on_treeview1_button_press_event(self,f_treeview,event): 
        print "button press event on treeview1" 
        if event.type == gtk.gdk.BUTTON_PRESS:    
            if event.button ==1:
                #self.display_tags(f_treeview,event)
                self.model_treeview2.clear()
                self.model_treeview3.clear()
                x = int(event.x)
                y = int(event.y)
                pthinfo = f_treeview.get_path_at_pos(x,y)
                if pthinfo != None:
                    l_path, col,cellx,celly = pthinfo
                    l_model = f_treeview.get_model()
                    self.l_iter = l_model.get_iter(l_path)
                    l_content = l_model[self.l_iter][2]
                    # print l_content
                    # populate the commons infos
                    for i in self.dico_tot.keys():
                        self.model_treeview2.append([i ,self.dico_tot[i]])
                    # print self.dico_files.keys()
                    l = self.dico_files[l_content]
                    # print l                                
                    self.model_treeview3.prepend(["SWAC_TECH_DATE",l[2]])
                    self.model_treeview3.prepend(["TITLE",l[1] ])
                    self.model_treeview3.prepend(["SWAC_TEXT",l[0]])

        elif event.type == gtk.gdk._2BUTTON_PRESS:
            print "double click"
            # on va entendre le son !!!
            if event.button ==1:
                x = int(event.x)
                y = int(event.y)
                pthinfo = f_treeview.get_path_at_pos(x,y)
                if pthinfo != None:
                    l_path, col,cellx,celly = pthinfo
                    l_model = f_treeview.get_model()
                    self.l_iter = l_model.get_iter(l_path)
                    l_contenu = l_model[self.l_iter][2]
                    self.play_sound(l_contenu)
  
     
    def on_treeview2_button_press_event(self,f_treeview,event): 
        
        print "button press event on treeview2"     
        if event.button == 3:
            f_treeview.get_model().append()
            self.have_to_generate = True

                
                
    def col0_edited_cb( self, cell, path, new_text, model ):
        """
        Called when a text cell is edited.  It puts the new text
        in the model so that it is displayed properly.
        """
        print "Change '%s' to '%s'" % (model[path][0], new_text)
        model[path][0] = new_text
        return
    
    def col1_edited_cb( self, cell, path, new_text, model ):
        """
        Called when a text cell is edited.  It puts the new text
        in the model so that it is displayed properly.
        """
        print "Change '%s' to '%s'" % (model[path][1], new_text)
        model[path][1] = new_text
        return
    
    def col2_edited_cb( self, cell, path, new_text, model ):
        """
        Called when a text cell is edited.  It puts the new text
        in the model so that it is displayed properly.
        """
        print "Change '%s' to '%s'" % (model[path][0], new_text)
        model[path][0] = new_text
        return
    
    def col3_edited_cb( self, cell, path, new_text, model ):
        """
        Called when a text cell is edited.  It puts the new text
        in the model so that it is displayed properly.
        """
        print "Change '%s' to '%s'" % (model[path][1], new_text)
        model[path][1] = new_text
        return
    
    def audio_type_cb(self, widget, data=None):
        self.toggle_audio = data
        print "toggleaudio:", self.toggle_audio
        
        self.renderer0.disconnect(self.my_connect_id)
        if self.toggle_audio == "tmp":
            self.treeview1.set_model(self.model_treeview1_tmp)
        elif self.toggle_audio == "flac":
            self.treeview1.set_model(self.model_treeview1_flac)
        elif self.toggle_audio == "ogg":
            self.treeview1.set_model(self.model_treeview1_ogg)
        elif self.toggle_audio == "mp3":
            self.treeview1.set_model(self.model_treeview1_mp3)
        else:
            print "no change"
        self.model_treeview2.clear()
        self.model_treeview3.clear()
        self.l_iter = self.treeview1.get_model().get_iter_root() 
        
        self.treeselection = self.treeview1.get_selection()
        if self.l_iter != None:
            self.treeselection.select_iter(self.l_iter)
            print "self.l_iter", self.l_iter  
            self.display_tags(self.l_iter)
        self.my_connect_id = self.renderer0.connect( 'toggled', self.col0_toggled_cb, self.treeview1.get_model())
        
    def col0_toggled_cb( self, cell, path, model ):
         """
         Sets the toggled state on the toggle button to true or false.
         """
         model[path][0] = not model[path][0]
         print "Toggle '%s' to: %s" % (model[path][0], model[path][1],)
         return
    
    def create_treeviews(self):
        # toggle buttons:
        self.xml_glade.get_widget("toolbutton12").connect("toggled", self.audio_type_cb, "flac")
        self.xml_glade.get_widget("toolbutton1").connect("toggled", self.audio_type_cb, "ogg")
        self.xml_glade.get_widget("toolbutton2").connect("toggled", self.audio_type_cb, "mp3")
        self.xml_glade.get_widget("toolbutton5").connect("toggled", self.audio_type_cb, "tmp")
        self.toggle_audio = "tmp"
        #
        self.treeview1 = self.xml_glade.get_widget("treeview1")
        self.treeview2 = self.xml_glade.get_widget("treeview2")
        self.treeview3 = self.xml_glade.get_widget("treeview3")
        #self.model_treeview1 = gtk.ListStore(gobject.TYPE_BOOLEAN,str,str)
        self.model_treeview2 = gtk.ListStore(str,str)
        self.model_treeview3 = gtk.ListStore(str,str)
        #self.treeview1.set_model(self.model_treeview1)
        self.model_treeview1_tmp = gtk.ListStore(gobject.TYPE_BOOLEAN,str,str)
        self.model_treeview1_flac = gtk.ListStore(gobject.TYPE_BOOLEAN,str,str)
        self.model_treeview1_ogg = gtk.ListStore(gobject.TYPE_BOOLEAN,str,str)
        self.model_treeview1_mp3 = gtk.ListStore(gobject.TYPE_BOOLEAN,str,str)
        #
        
        self.treeview2.set_model(self.model_treeview2)
        self.treeview3.set_model(self.model_treeview3)
        #
        self.renderer0 = gtk.CellRendererToggle()
        self.renderer0.set_property('activatable', True)
        #self.renderer0.connect( 'toggled', self.col0_toggled_cb, self.treeview1.get_model())
        self.col0_treeview1 = gtk.TreeViewColumn("To be deleted",self.renderer0)
        self.col0_treeview1.add_attribute( self.renderer0, "active", 0)
        self.treeview1.append_column(self.col0_treeview1)
        #
        self.col1_treeview1 = gtk.TreeViewColumn("Word/Phrase", gtk.CellRendererText(),text=1)
        self.treeview1.append_column(self.col1_treeview1)
        #
        self.col2_treeview1 = gtk.TreeViewColumn("File", gtk.CellRendererText(),text=2)
        self.treeview1.append_column(self.col2_treeview1)
        #
        renderer = gtk.CellRendererText()
        renderer.set_property( 'editable', True )
        renderer.connect( 'edited', self.col0_edited_cb, self.model_treeview2 )
        #
        renderer1 = gtk.CellRendererText()
        renderer1.set_property( 'editable', True )
        renderer1.connect( 'edited', self.col1_edited_cb, self.model_treeview2 )
        #
        renderer2 = gtk.CellRendererText()
        renderer2.set_property( 'editable', True )
        renderer2.connect( 'edited', self.col2_edited_cb, self.model_treeview3 )
        #
        renderer3 = gtk.CellRendererText()
        renderer3.set_property( 'editable', True )
        renderer3.connect( 'edited', self.col3_edited_cb, self.model_treeview3 )
        #
        self.col1_treeview2 = gtk.TreeViewColumn("Tag name", renderer,text=0)
        self.treeview2.append_column(self.col1_treeview2)
        self.col2_treeview2 = gtk.TreeViewColumn("Tag content", renderer1,text=1)
        self.treeview2.append_column(self.col2_treeview2)
        #
        self.col1_treeview3 = gtk.TreeViewColumn("Tag name", renderer2,text=0)
        self.treeview3.append_column(self.col1_treeview3)
        self.col2_treeview3 = gtk.TreeViewColumn("Tag content", renderer3,text=1)
        self.treeview3.append_column(self.col2_treeview3)
        #
        self.col1_treeview1.set_resizable(True)
        self.col2_treeview1.set_resizable(True)
        self.col1_treeview1.set_sort_column_id(0)
        
        self.col1_treeview2.set_resizable(True)
        self.col2_treeview2.set_resizable(True)
        #
        self.col1_treeview3.set_resizable(True)
        self.col2_treeview3.set_resizable(True)
        #
        self.treeview1.set_search_column(0)
        self.treeview1.set_reorderable(True)
        self.treeview1.set_headers_clickable(True)
        
        self.treeview1.set_rules_hint(True)
        self.treeview2.set_rules_hint(True)
        self.treeview3.set_rules_hint(True)
        self.treeviews_create = False
        self.have_to_generate = False
        #
        
            
    def on_menuitem11_activate(self,widget,data=None):
        print "on_menuitem11_activate: audiolist"
        # test if the audio files were generated
        # if not, ask to generate or abort
        # test if a project was open
        self.update_word_dic()
        if self.my_project_open:
            self.home_dir = os.path.expanduser("~")
            self.yazik_dir = os.path.join(self.home_dir,".yazik/")
            self.audio_dir = os.path.join(self.home_dir,".yazik/audio")
            self.data_dir = os.path.join(self.yazik_dir,"data")
            self.list_dir = os.path.join(self.data_dir, self.my_infos.list_name)
            list_filename = os.path.join(self.audio_dir,self.my_infos.list_name +".index.txt")
            ####" the part above to share with other parts
            if not os.path.lexists(list_filename):
                message = gtk.MessageDialog(None, gtk.DIALOG_MODAL, gtk.MESSAGE_WARNING, gtk.BUTTONS_CLOSE, \
                                        "Audio files not generated. \n Please, generate them before enter here?")
                resp = message.run()
                message.destroy()
                return
            self.audiolist = self.xml_glade.get_widget("window3")
            if self.treeviews_create:
                self.create_treeviews()
            self.populate_window3()
            self.audiolist.show()
        else:
            message = gtk.MessageDialog(None, gtk.DIALOG_MODAL, gtk.MESSAGE_WARNING, gtk.BUTTONS_CLOSE, \
                                        "Open a project first, please!")
            resp = message.run()
            message.destroy()
            return
        
        
        
    def on_menuitem12_activate(self,widget,data=None):
        print "on_menuitem12_activate: deleting all the temp files"
        message = gtk.MessageDialog(None, gtk.DIALOG_MODAL, gtk.MESSAGE_QUESTION, gtk.BUTTONS_YES_NO, \
                                    "Do you REALLY want to delete \n All the temporary audio files?")
        resp = message.run()
        print resp
        if resp == gtk.RESPONSE_YES:
            print "ok"
            home_dir = os.path.expanduser("~")
            print home_dir
            yazik_dir = os.path.join(home_dir,".yazik/")
            print yazik_dir
            d = os.path.join(yazik_dir,"audio/tmp/")
            print d
            os.chdir(d)
            g = glob.glob("*.flac")
            print g
            for gg in g:
                print gg
                os.remove(gg)
        elif resp == gtk.RESPONSE_NO:
            print "no"
        else:
            print "no no"
        message.destroy()
        self.get_recorded()
        self.update_word_dic()
        

    def on_entry6_editing_done(self,widget,data=None):
        #print "on_entry6_editing_done"
        entry6_widget = self.xml_glade.get_widget("entry6")
        l_langue = entry6_widget.get_text()
        l_langue = l_langue[:3]
        #print l_langue
        if not self.langage.exist_iso_name(l_langue):
            print "error: wrong iso language name"
            entry6_widget.modify_base(gtk.STATE_NORMAL, gtk.gdk.color_parse("red"))
            entry6_widget.grab_focus()
        else:
            entry6_widget.modify_base(gtk.STATE_NORMAL, None)
            entry6_widget.set_text(l_langue)

    def on_entry7_editing_done(self,widget,data=None):
        #print "on_entry7_editing_done"
        entry7_widget = self.xml_glade.get_widget("entry7")
        l_country = entry7_widget.get_text()
        l_country = l_country[:2]
        #print l_country
        if not self.country.exist_iso_name(l_country):
            print "error: wrong country iso name"
            entry7_widget.modify_base(gtk.STATE_NORMAL, gtk.gdk.color_parse("red"))
            entry7_widget.grab_focus()
        else:
            entry7_widget.modify_base(gtk.STATE_NORMAL, None)
            entry7_widget.set_text(l_country)
            
    def on_entry10_editing_done(self,widget,data=None):
        #print "on_entry10_editing_done"
        entry10_widget = self.xml_glade.get_widget("entry10")
        l_country = entry10_widget.get_text()
        l_country = l_country[:2]
        #print l_country
        if not self.country.exist_iso_name(l_country):
            print "error: wrong country iso name"
            entry10_widget.modify_base(gtk.STATE_NORMAL, gtk.gdk.color_parse("red"))
            entry10_widget.grab_focus()
        else:
            entry10_widget.modify_base(gtk.STATE_NORMAL, None)
            entry10_widget.set_text(l_country)

    def on_entry8_editing_done(self,widget,data=None):
        #print "on_entry8_editing_done"
        entry8_widget = self.xml_glade.get_widget("entry8")
        l_langue = entry8_widget.get_text()
        #print l_langue
        l_langue = l_langue[:3]
        if not self.langage.exist_iso_name(l_langue):
            print "error: wrong language iso name"
            entry8_widget.modify_base(gtk.STATE_NORMAL, gtk.gdk.color_parse("red"))
            entry8_widget.grab_focus()
        else:
            entry8_widget.modify_base(gtk.STATE_NORMAL, None)
            entry8_widget.set_text(l_langue)
            
    def on_togglebutton1_toggled (self,widget,data=None):
        #print "toggle1 button activated"
        toggle1_widget = self.xml_glade.get_widget("togglebutton1")
        if toggle1_widget.get_active():
          # If control reaches here, the toggle button is down
            toggle1_widget.set_label("Overwriting all")
            self.overwriting = True
        else:
            # If control reaches here, the toggle button is up
            toggle1_widget.set_label("Adding new only")
            self.overwriting = False

    def on_entry1_focus_in_event(self,widget,data=None):
        #print "focus!"
        # we get the prj files for completion
        self.build_project_completion()

        
    def on_entry6_focus_in_event(self,widget,data=None):
        #print "focus!"
        self.build_langage_completion("entry6")
        
    def on_entry7_focus_in_event(self,widget,data=None):
        #print "focus!"
        self.build_country_completion("entry7")

    def on_entry10_focus_in_event(self,widget,data=None):
        #print "focus!"
        self.build_country_completion("entry10")

        
    def on_entry8_focus_in_event(self,widget,data=None):
        #print "focus!"
        self.build_langage_completion("entry8")

    def on_entry1_activate(self,widget,data=None):
        filename = self.xml_glade.get_widget("entry1").get_text()
        self.my_infos.locutor_name = filename.replace("_"," ")
        self.my_infos.load_locutor_infos(filename)

    def textview1_buffer_changed(self,l_buffer):
        #print "buffer changed"
        l_mark = l_buffer.get_insert()
        l_iter = l_buffer.get_iter_at_mark(l_mark)
        the_line = l_iter.get_line()
        #print "the line number:", the_line    
        ending = l_iter.copy()
        l_iter.set_line(the_line)
        if not ending.ends_line():
            ending.forward_to_line_end()
        the_text = l_iter.get_text(ending)
        #print "text=:",the_text
        if the_text.find("#") != -1:
            #print "comment char here"   
            tmp_iter = l_iter.copy()
            pos = the_text.rfind("#")
            tmp_iter.forward_chars(pos)
            l_buffer.apply_tag_by_name("lightgrey",tmp_iter,ending)
  

    def on_textview2_button_press_event(self,vidget,event):
        print "button press event on the textview2"
        l_widget = self.xml_glade.get_widget("textview2")
        if event.type == gtk.gdk.BUTTON_PRESS:
            print "single click"
            if event.button ==1:
                x = int(event.x)
                y = int(event.y)
                print x,y
                x, y = l_widget.window_to_buffer_coords(gtk.TEXT_WINDOW_TEXT, x, y)
                iter_here = l_widget.get_iter_at_location(x, y)
                # which line ?
                the_line = iter_here.get_line()
                print "the line", the_line
                ending = iter_here.copy()
                iter_here.set_line(the_line)
                ending.forward_to_line_end()
                the_text = iter_here.get_text(ending)
                print the_text
                self.the_entry = the_text[0:3]
                print self.the_entry
        if event.type == gtk.gdk._2BUTTON_PRESS:
            print "double clic"
            if event.button ==1:
                x = int(event.x)
                y = int(event.y)
                print x,y
                x, y = l_widget.window_to_buffer_coords(gtk.TEXT_WINDOW_TEXT, x, y)
                iter_here = l_widget.get_iter_at_location(x, y)
                # which line ?
                the_line = iter_here.get_line()
                print "the line", the_line
                ending = iter_here.copy()
                iter_here.set_line(the_line)
                ending.forward_to_line_end()
                the_text = iter_here.get_text(ending)
                print the_text
                self.the_entry = the_text[0:3]
                print self.the_entry
                self.xml_glade.get_widget(self.langage_entry).set_text(self.the_entry)
                #self.dialog1.hide()
                
            
            
            
    def on_textview3_button_press_event(self,widget,event):
        print "button press event on the textview3"
        l_widget = self.xml_glade.get_widget("textview3")
        if event.type == gtk.gdk.BUTTON_PRESS:
            #print "single click"
            if event.button ==1:
                x = int(event.x)
                y = int(event.y)
                #print x,y
                x, y = l_widget.window_to_buffer_coords(gtk.TEXT_WINDOW_TEXT, x, y)
                iter_here = l_widget.get_iter_at_location(x, y)
                # which line ?
                the_line = iter_here.get_line()
                #print "the line", the_line
                ending = iter_here.copy()
                iter_here.set_line(the_line)
                ending.forward_to_line_end()
                the_text = iter_here.get_text(ending)
                #print the_text
                self.the_entry = the_text[0:2]
                #print self.the_entry
        if event.type == gtk.gdk._2BUTTON_PRESS:
            #print "double clic"
            if event.button ==1:
                x = int(event.x)
                y = int(event.y)
                #print x,y
                x, y = l_widget.window_to_buffer_coords(gtk.TEXT_WINDOW_TEXT, x, y)
                iter_here = l_widget.get_iter_at_location(x, y)
                # which line ?
                the_line = iter_here.get_line()
                p#rint "the line", the_line
                ending = iter_here.copy()
                iter_here.set_line(the_line)
                ending.forward_to_line_end()
                the_text = iter_here.get_text(ending)
                #print the_text
                the_entry = the_text[0:2]
                self.xml_glade.get_widget(self.country_entry).set_text(self.the_entry)
                #print the_entry
            
    def populate_langage_infos(self):
        l_widget = self.xml_glade.get_widget("textview2")
        self.textview2_buffer = l_widget.get_buffer()
        l_list = self.langage.get_list()
        for i in l_list:
            self.textview2_buffer.insert_at_cursor(i + "\n")

    def populate_country_infos(self):
        l_widget = self.xml_glade.get_widget("textview3")
        self.textview3_buffer = l_widget.get_buffer()
        l_list = self.country.get_list()
        for i in l_list:
            self.textview3_buffer.insert_at_cursor(i + "\n")

    def build_project_completion(self):
        completion = gtk.EntryCompletion()
        liststore = gtk.ListStore(str)
        # populate the liststore
        home_dir = os.path.expanduser("~")
        filter = os.path.join(home_dir,".yazik/*.locu")
        file_list = glob.glob(filter)
        for i in file_list:
            i = os.path.basename(i)
            i = i.split(".")[0]
            #print i
            liststore.append([i])
            #print i
        completion.set_model(liststore)
        self.xml_glade.get_widget("entry1").set_completion(completion)
        completion.set_text_column(0)

    def build_langage_completion(self,f_widget):
        completion = gtk.EntryCompletion()
        liststore = gtk.ListStore(str)
        l_list = self.langage.get_list()
        for l in l_list:
            liststore.append([l])
        completion.set_model(liststore)
        self.xml_glade.get_widget(f_widget).set_completion(completion)
        completion.set_text_column(0)
        
    def build_country_completion(self,f_widget):
        completion = gtk.EntryCompletion()
        liststore = gtk.ListStore(str)
        l_list = self.country.get_list()
        for l in l_list:
            liststore.append([l])
        completion.set_model(liststore)
        self.xml_glade.get_widget(f_widget).set_completion(completion)
        completion.set_text_column(0)


    def get_recorded(self):
        # add : only if new records !! (when the recorder is lauched)
        self.recorded = []
        os.chdir(os.path.join(self.my_infos.audio_dir,"tmp"))
        l = glob.glob("*.flac")
        #print l
        for i in l:
            i = i.split(".")[0]
            self.recorded.append(i)
        self.to_be_updated = False

    def is_recorded(self,f_code):
        return (f_code in self.recorded)

    def update_word_dic(self):
        #print "updating the word dictionnary"
        if self.to_be_updated:
            self.get_recorded()
        ph = self.my_phrases.get_list()
        self.word_dic = {}
        j = 0
        for i in ph:
            code = self.my_CRC32name_class.get(i)
            if self.is_recorded(code):
                self.word_dic[code] = [i,1,j]
            else:
                self.word_dic[code] = [i,0,j]
            #print i, "->", self.word_dic[i]
            j = j + 1
        #self.highlight_button(False)
        #print self.word_dic
        self.colorize()

 #   def highlight_button(self,f_mode):
        # will see later how to change the color of the background
#        colormap = self.update_button.get_colormap()
#        red = colormap.alloc_color(65535, 0, 0)
#        normal = self.update_button.get_style().bg[gtk.STATE_NORMAL]
        #print "modifying the button"
#        if f_mode:
#            self.update_button.set_label("Click here after typing your word/phrase")
#            self.update_button.modify_bg(gtk.STATE_NORMAL,red)
#       else:
#            self.update_button.set_label("Update the list of allready recorded audio files")
#            self.update_button.modify_bg(gtk.STATE_NORMAL,normal)

    def splash_set_label(self,f_text):
        self.my_splash_label.set_text(f_text)
        while gtk.events_pending():
            gtk.main_iteration()

    def splash_destroy(self):
        self.my_splash.destroy()

    def build_colors(self):
        l_buffer = self.xml_glade.get_widget("textview1").get_buffer()
        c1 = gtk.gdk.color_parse("lightgreen")
        c2 = gtk.gdk.color_parse("lightgrey")
        self.tag1 = l_buffer.create_tag("lightgreen",foreground_gdk=c1)
        self.tag2 = l_buffer.create_tag("lightgrey",foreground_gdk=c2)


    def colorize(self):
        #print self.word_dic
        l_buffer = self.xml_glade.get_widget("textview1").get_buffer()
        startiter = l_buffer.get_start_iter()
        enditer = l_buffer.get_end_iter()
        # removing all tags
        l_buffer.remove_all_tags(startiter, enditer)
        #
        word_startiter = startiter
        word_enditer = startiter.copy()

        status  = True
        while status:
            #print "num line: ",word_startiter.get_line()
            if word_enditer.forward_to_line_end():
                #print "we are at the end of line"
                #print "number of chars", word_startiter.get_chars_in_line()
                phrase = word_startiter.get_slice(word_enditer)
                word = phrase.split("#")[0].rstrip("\n\f\r").strip()
                #print "word: ","*" + word +"*"
                code = self.my_CRC32name_class.get(word)
                if self.is_recorded(code):
                    tmp_iter = startiter.copy()
                    tmp_iter.forward_chars(len(word))
                    l_buffer.apply_tag_by_name("lightgreen",word_startiter,tmp_iter)
                if len(phrase.split("#")) > 1:
                    tmp_iter = startiter.copy()
                    pos = phrase.rfind("#")
                    tmp_iter.forward_chars(pos)
                    l_buffer.apply_tag_by_name("lightgrey",tmp_iter,word_enditer)
            status = word_startiter.forward_line()

    def set_button_activ(self,f_mode):
        #self.update_button = self.xml_glade.get_widget("button12")
        self.recording_button = self.xml_glade.get_widget("button5")
        self.toolitem5 = self.xml_glade.get_widget("toolitem5")
        self.toolitem6 = self.xml_glade.get_widget("toolitem6")
        self.imagemenuitem3 = self.xml_glade.get_widget("imagemenuitem3")
        self.imagemenuitem4 = self.xml_glade.get_widget("imagemenuitem4")
        self.menuitem7 = self.xml_glade.get_widget("menuitem7")
        self.menuitem8 = self.xml_glade.get_widget("menuitem8")
        #            
        #self.update_button.set_sensitive(f_mode)            
        self.recording_button.set_sensitive(f_mode)
        self.toolitem5.set_sensitive(f_mode)
        self.toolitem6.set_sensitive(f_mode)
        self.imagemenuitem3.set_sensitive(f_mode)
        self.imagemenuitem4.set_sensitive(f_mode)
        self.menuitem7.set_sensitive(f_mode)
        self.menuitem8.set_sensitive(f_mode)
            
        
    def window1_main(self):
        self.splash_set_label("Initialising the dir structure" )
        self.my_splash_label.set_fraction(0.05)
        my_dirbase = dirbase.Dirbase()
        self.splash_set_label("Initialising the name class")
        self.my_splash_label.set_fraction(0.20)
        self.my_name_class = name.Name()
        self.my_CRC32name_class = name.CRC32Name()
        self.splash_set_label("Initialising the langage class")
        self.my_splash_label.set_fraction(0.35)
        self.langage = langage.Langage()
        self.langage.main()
        self.splash_set_label("Initialising the country class")
        self.my_splash_label.set_fraction(0.50)
        self.country = country.Country()
        self.country.main()
        self.splash_set_label("Loading the words/phrases")
        self.my_splash_label.set_fraction(0.65)
        # text widget
        self.text_widget = self.xml_glade.get_widget("textview1")
        self.textview1_buffer = self.text_widget.get_buffer()
        self.textview1_buffer.connect("changed",self.textview1_buffer_changed)
        self.clipboard = gtk.Clipboard(gtk.gdk.display_manager_get().get_default_display(),"CLIPBOARD")
        self.text_widget.drag_dest_set( gtk.DEST_DEFAULT_MOTION |
            gtk.DEST_DEFAULT_HIGHLIGHT | gtk.DEST_DEFAULT_DROP,
                self.dnd_list, gtk.gdk.ACTION_COPY)
        self.my_phrases = phrases.Phrases(self.text_widget)
        self.splash_set_label("Initialising the helper widgets")
        self.my_splash_label.set_fraction(0.80)
        self.populate_langage_infos()
        self.populate_country_infos()
        self.splash_set_label("Initialising the infos")
        self.my_splash_label.set_fraction(0.95)
        self.my_infos = infos.Infos(self.xml_glade)
        self.my_infos.main()
        self.my_project_open = False
        self.main_window.show()
        self.build_colors()
        self.my_splash.hide()
        self.word_dic = {}
        self.recorded = []
        self.overwriting = False
        self.to_be_updated = True
        self.langage_entry = None
        self.listen_widget = self.xml_glade.get_widget("toolbutton3")
        b = self.xml_glade.get_widget("togglebutton1")
        b.set_active(self.overwriting)
        b.set_label("Adding new only")
        self.set_button_activ(True)
        #
        self.treeviews_create = True
        return False
    
    def want_to(self,f_message):
        message = gtk.MessageDialog(None, gtk.DIALOG_MODAL, gtk.MESSAGE_QUESTION, gtk.BUTTONS_YES_NO, \
                                    f_message)
        resp = message.run()
        #print resp
        message.destroy()
        if resp == gtk.RESPONSE_YES:
            #print "ok"
            return True
        elif resp == gtk.RESPONSE_NO:
            #print "no"
            return False
        else:
            #print "no no"
            return False
        
    
    def on_window3_delete_event(self,widget,event,data=None):
        if self.have_to_generate:
            res  =  self.want_to("The tags were modified. \n\n Do you want to save the modifications \n in the index and the audio files?")
        self.audiolist.hide()
        return True

    def  on_window3_destroy(self,widget,data=None):
        if self.have_to_generate:
            res = self.want_to("The tags were modified. \n\n Do you want to save the modifications \n in the index and the audio files?")
        self.audiolist.hide()       

#######################################################

    def on_window1_delete(self,widget,event,data=None):
        return False

    def  on_window1_destroy(self,widget,data=None):
        gtk.main_quit()

    def main(self):
        self.my_splash = self.xml_glade.get_widget("window2")
        self.my_splash_label = self.xml_glade.get_widget("progressbar1")
        self.my_splash_label.set_text("Initialising")
        self.my_splash.show()
        while gtk.events_pending():
            gtk.main_iteration()
        #source_id = gobject.timeout_add(6000, self.my_splash.hide) # splash screen ...
        gobject.idle_add(self.window1_main)
        # and the main loop!
        gtk.main()
